#!/usr/bin/perl -T
# add-response.pl
# Copyright Board of Trustees of the University of Illinois at UC, April 1995

# This is the action for the FORM returned by preview-response.pl.

# Add current directory to load path.
$0 = $ENV{SCRIPT_FILENAME} if $0 =~ m{^/dev};
$0 =~ m{^(.*)/[^/]+$ }x;   $hnbin = $1 || '.';
unshift(@INC, $hnbin, "$hnbin/.scripts"); 

# exit(0);

require 'Admin/hnrc';
&feval('&addResponsePL');

#use CGI;

sub addResponsePL {

  local $debug = 0;
  
  require "formlib.pl";
  require "add-lib.pl";
  require "member-lib.pl";

#  &print_Content_type();  # Do this here to hopefully catch any errors.

  my %form = &GetFormArgs();

# Debugging here will mess up status code for mail-incoming.
# local $debug ||= ($form{remoteUser} eq $mail_admin);

# Setting plaintext doesnt work here.
# local $plaintext = ($form{remoteUser} eq $mail_admin);  

  &HNENV() if $debug;

  &printAssoc("Form", %form) if $debug;

#  &HNMsg("form{userName}: '$form{userName}'") if $debug;
#  &HNMsg("form{Date}: '$form{Date}'") if $debug;

#  &check_userid_email($form{userid}, $form{email});  nothing to check yet.

  &checkAuthenticated($form{userid}, $form{password},
		      $form{remoteUser}, 
		      $form{adminPassword} || $form{password});

  $userid = $form{'userid'} || $remoteUser;
  $userid =~ s{^\s*}{}; # Remove whitespace
  $userid =~ s{\s*$ }{}x;
  $userid = &useridOf($userid);
  $remoteUser ||= $userid;
  &HNMsg("remoteUser = $remoteUser") if $debug;

  $userName = &URLdecode($form{userName});

#  &HNMsg("userid = $userid") if $debug;
#  &HNMsg("userName: $userName") if $debug;

  ($userid, $userName) =
    &ProcessMemberInfo($userid, $userName);
  
  &HNMsg("userid = $userid") if $debug;
  &HNMsg("userName: $userName") if $debug;

#  $query = new CGI;
#  $attachment = $query->param('attachment');
#  $query->tmpFileName($attachment);
  # untar it
#  system "tar -xf .."; 

  $annotateOrRespond = $ENV{QUERY_STRING};
  
  $URL = $form{'URL'};
  $URL ||= $ENV{'PATH_INFO'};  # hidden vars get dropped when form reloaded.

  $title = $form{'title'};
  &HNMsg("title4: '$title'") if $debug;
  $title = &URLdecode($title);       # do it once more
  &HNMsg("title3: '$title'") if $debug;
  $subject = &unescapeHTML($title);  # leave title HTML escaped.
  &HNMsg("subject: '$subject'") if $debug;

  $keywords = &URLdecode($form{'keywords'});

  $referenceURL = $form{'referenceURL'};
  $annotationType = $form{'annotationType'};
  &HNMsg("annotationType: $annotationType") if $debug;
  $contentType = $form{'contentType'};

  $bodyURL = $form{'bodyURL'};
  # Untaint bodyURL.
  $bodyURL = &untaintPath($bodyURL);
  #  &debugvar('bodyURL(1)', $bodyURL);

#  $bodyURL =~ m,^([-\w0-9./]+),;  # Is this safe enough?
#  $bodyURL = $1;
#  $bodyURL =~ s,(^|/)[^/]+/\.\.,,g; # Collapse all 'dir/..'.

#  if ($bodyURL =~ m,^\.\.,) {
#      &HNUserError("Relative path '$bodyURL' not allowed.");
#  }
  
  $body = $form{'body'};  # Email input
  # $previousURL = $form{'previousURL'};

  $messageID = $form{'messageID'};
  # Extract the guts of the message ID.  May be followed by comment text.
  $messageID =~ m{<([^>]+)>};
  $messageID = $1;
  #$messagePath = $form{'path'};
  $headerString = $form{'headerString'};


  $inreplyto = $form{'inreplyto'};

  $referenceString = $form{'references'};
  @references = split (' ', $referenceString);  # No ' ' in message IDs?

  $sender = $form{'sender'};
  $envelopeSender = $form{'envelope-sender'};
  $errorsto = $form{'errors-to'};
  $to = $form{'to'};
  $cc = $form{'cc'};
  # $MailMsgDate = $in{'Date'};  need to convert the date format.

  $newsgroups = $form{'newsgroups'};
  $forum = $form{'forum'};  # Set by -f option to mail-incoming.pl
  &HNMsg("Forum: '$forum'") if $debug;
  
  $rFrame = $form{'frameString'} eq 'response';
  $oFrame = $form{'frameString'} eq 'outline';
  $baseFrameURL = $form{'baseFrame'};

  $visible = $form{'visibility'};
  
  $upRel = $form{'upRel'};
  $Subscription = $form{'subscription'};


  ###############################################################3
  # Process email.

  if ($inreplyto || @references || $newsgroups || $forum) {
      # If any of the above are true, assume this is an email posting.

      #=================================================
      # Check if incoming email has been seen at this server already.

    &HNMsg("messageID is $messageID\n") if $debug;
    my ($midfile, $midhost) = split('@', $messageID);
    my $prefix;
    if ($midfile =~ m/:/) {
      ($prefix, $midfile) = split(':', $midfile);
    }
    &HNMsg("midfile = $midfile\nmidhost = $midhost") if $debug;
    
    # Is it an hn ID?
    if ($midhost eq $ENV{SERVER_NAME} && 
	($prefix eq $hnGroup)) {
      &HNMsg ("Domain name Matched") if $debug;
      if ($midfile =~ m{^\"?([^\"\@]+)}) {
	my $path = $1;
	if (-e "$hndocs$path.html,urc") {
	  &HNMsg("Already posted here - not really an error");
	  exit 0;  # But quit now anyway.
	}
      }
    }
    
    # Is it a known mid?
    my $middir = &untaintPath(&fliphostname($midhost));
    $midfile = &untaintPath($midfile);

    my $midpath = "$hnmidDB/$middir/$midfile,urc";
    &HNMsg ("midpath: '$midpath'") if $debug;
    if (-e $midpath) {
      &HNMsg ('Attempting to post a message with existing MID');
      exit 0;
    }

    #========================================
    # If we get this far, it's a new message.

    my $processMsg;	# Accumlated message about processing the posting
    my $moreMsg;	# A single message to be appended to $processMsg.
    
    if ($inreplyto) {
      # This definitly means the message was posted via email,
      # unless the post was faked, which could be attempted, but the
      # mailAdmin password would not be known by the faker so it should fail.
      &HNMsg("In-Reply-To: $inreplyto") if $debug;
      # It might be an irrelevant In-Reply-To.
      ($URL, $moreMsg) = &CheckUpLink ($URL, $inreplyto); 
      $processMsg .= $moreMsg;
      &HNMsg("URL: '$URL'") if $debug;
    }

    @references = reverse @references;   # Check the last one first.
    while (!$URL && @references) {
	my $reference = shift @references;
	($URL, $moreMsg) = &CheckUpLink ($URL, $reference);
	$processMsg .= $moreMsg;
    }

    
    # No explicit reference message ID, so next we could try
    # threading by subject (Re: previous subject) and body references.
    # But that is hard so, the message ends up as top-level,
    # if we know what forum to put it in.

    if (!$URL && $forum) {
      # Forum spec overrides Newsgroups line.
      $forum = "$forum.html" if ($forum !~ m{\.html$ }x);
      $forum = "/$forum" if ($forum !~ m{^/});
      $URL = $forum;
      ($URL, $moreMsg) = &CheckUpLink ($URL, 0); 
      $processMsg .= $moreMsg;
    }
    
    # The Newsgroups line might be set for a top-level email posting.
    if (!$URL && $newsgroups) {
      # Look for a newsgroup we know how to map to a HyperNews group.
      my @newsgroups = split (/[\s,]/, $newsgroups);
      &HNMsg("newsgroups: @newsgroups") if $debug;
      foreach $group (@newsgroups) {
	# Need to match on equivalent prefixes.  Need a list of equivalents.
	# $hnprefixEquiv is intended for that.
	# Also need to post to *all* the local groups that are appropriate
	# rather than just the first.
	if ($group =~ m,^$http.+/$get,) {
	  # Found it.
	  $URL = $';
	  ($URL, $moreMsg) = &CheckUpLink ($URL, 0); 
	  $processMsg .= $moreMsg;
	  last;			# Quit now - but this is wrong.
	}
      }
    }
    
    if ($URL) {
      # Save the body
      &HNMsg("--------Body-----\n$body----------") if $debug;
      $bodyURL = &saveBody($body, $contentType, "/hn_tmp$$");
    }
  }

  # If no $URL at this time, then we don't know where to post it.
  if (!$URL) {
    &EmailRejection(

"$hnSystemName does not know where to post this message.  

If you are replying to mail, maybe your reply did not correctly
specify what you were replying to.  You need to include an
'In-Reply-To' header line with the message ID of the message you are
replying to.  Outgoing mail messages include exactly the line you need
to add.

If your mail program does not permit you to add new header lines,
$hnSystemName permits you to include the header lines 
at the top of the body of your message.

If you did include the In-Reply-To line, perhaps something is wrong with
that line.  Or perhaps the message you are replying to has been deleted.

You can also send a message directly to a forum by including a
'Newsgroups' header line with the URL of the forum.  

$processMsg
");
  }


  &HNMsg("URL: '$URL'") if $debug;

  ###############################################################
  # We have to know where a message is being posted before we can
  # tell whether the user can do the posting.
  # This is especially true when we have per-forum access restrictions.
  
  %resp = &parseURCFile("$hndocs$URL,urc");
   
    
  $base = $resp{'BaseURL'};
  $responses = $resp{'Responses'};
  $upTitle = $resp{'Title'};

  &HNMsg("remoteUser = $remoteUser; userid = $userid") if $debug;
  # Access control is different here than for preview and editing because
  # mail-incoming may be posting a message for the user using $mail_admin.

  &access1($addResponseSF, 2, $userid, $remoteUser, 
	   "User '<strong>$remoteUser</strong>'
 is not permitted to add a message for '$userid'.<p>", 
	   $authenticated, $base);
    
  my %response = 
    ('Title' , $title,
     'URL' , $URL,		# really upURL relative.
     'MessageID', $messageID,
     # 'Path', $messagePath,
     'Keywords' , $keywords,
     'AnnotationType' , $annotationType,
     'ContentType' , $contentType,
     'Body' , $bodyURL,
     'UpRel' , $upRel,
     'BaseURL' , $base,
     'Responses' , $responses,
     'From' , $userid,
     'Name' , $userName,
     'Visibility', $visible,
     'Date',  $MailMsgDate
    );
  
  #  &debugvar('bodyURL(2)', $bodyURL);

  &HNMsg ("Before AddResponse\n") if $debug;
  &AddResponse('notify', 0, %response);
  &HNMsg ("After AddResponse\n") if $debug;

  if (!$URL || $URL =~ m,^/[0-9],) {
    &HNError('Congratulations! You have been bitten by a HyperNews bug. <P>

 For some reason, the message you have posted has ended up in a "null"
 forum with no name.  I want to find out how this is happening, but as
 of yet, I know of no pattern.  So please provide as much information
 as you can that might be relevant, including the data listed below.
 Mail to <A
 HREF="mailto:liberte@hypernews.org">liberte@hypernews.org</A>.  Here
 are a few questions. <P>

<UL>

<LI> Does this occur every time you post?  Have you posted more than once? <P>

<LI> What message or forum were you adding your message to? (Give the URL.)
 Reload, refresh, or revisit that page (if you are using Netscape or
 MSIE, it might be <strong><A
 HREF="javascript:history.go(-3)">here</A></strong>).  Did your
 message get added to the page anyway? <P>

<LI> How did you go about replying?  Did you change the URL on the
 edit-response page, or reload the edit-response form, or preview your
 message multiple times, or anything of that nature that you can
 remember? <P>

</UL>

If you provide this information, I may be able to help you
post your message.  Thanks!
 
');
  }
  
  if ($annotateOrRespond eq "Annotation") {
    &HNMsg ("Annotation get is $an_getURL\n") if $debug;
    &HNMsg ("Redirect to $an_getURL$URL\n") if $debug;
    
    print "Location: $an_getURL$URL\n";

    # The following causes problems for some browsers.
    #&print_HTML_HEAD($title);
    #print "Message added to <A HREF=\"$an_getURL$URL\">$upTitle</A>." 
    # if $debug;

    # Instead, just end the headers.
    print "\n";

  } else {	
    &addResponseResult();
  }

  &printEnd();
}


sub EmailRejection {
  my ($msg) = @_;
  my $whoto = $envelopeSender || $errorsto || $sender || $userid;
  my $recipients = join (",\n  ", (($to, $cc) || 'Unknown'));

  require 'email.pl';
  &sendmail(HYPERNEWS, $whoto);

  # We need a more suitable format and headers for this reject notice.
  print HYPERNEWS "Subject: $hnSystemName Posting Error

You have sent email to:

  $recipients 

to be posted by $hnSystemName.

$msg

   ----- Unsent message follows -----
$headerString

$body
";

  close HYPERNEWS;

  local $plaintext = 1;

  &print_HTML_HEAD("Posting Rejected");
  print $msg;

  &printEnd();
  exit;
}


sub CheckUpLink {
  local($URL, $upmsgid) = @_;
  # Figure out if we know where to post this message.
  # URL is a hn path.  $upmsgid is a message id of potential parent.
  
  my $updomain;
  my $upMIDFile;

  if ($upmsgid) {
    # URL processing (in-reply-to processing) 
    # Extract URL from HyperNews Message ID if present
    # process HyperNews Type MID

      $upmsgid =~ s{^[^<]*<\s*}{};   # remove junk up to first '<'
      $upmsgid =~ s{^([^>]+)>.*$ }{$1}x;   # remove junk from first '>' to end

    my ($midfile, $midhost) = split('@', $upmsgid);
    
    $upMIDFile = $midfile;
    $updomain = $midhost;
    &HNMsg ("upmsgid = '$upmsgid'\nupMIDFile = $upMIDFile") if $debug;  
    &HNMsg ("updomain = '$updomain'") if $debug;
    
    $URL = '';
    # Check if this is a HyperNews mid.
    # We should match on equivalent servers names....
    if ($updomain eq $ENV{SERVER_NAME}) {
      &HNMsg ("Domain name Matched") if $debug;
      # Some mail programs strip out the '"'s in message IDs.
      if ($upMIDFile =~ m{^\"?([^\"\@]+)}) {
	my $path = $1;
	my $prefix;
	if ($path =~ m,:,) {
	  ($prefix, $path) = split(':', $path);
	}
	&HNMsg("prefix: $prefix\npath: $path") if $debug;
	# This will break old HN IDs, when the prefix changes, for example.
	if ($prefix eq $hnGroup) {
	  &HNMsg ("\nAttempting to parseURCFile:$hndocs$path.html,urc\n") 
	    if $debug; 
	  my %urc = &parseURCFile("$hndocs$path.html,urc");
	  if ($urc{'Responses'}) {
	    $URL = "$urc{'Responses'}.html";
	  }
	  &HNMsg ("\nfound in URC Responses: $urc{'Responses'}\n") if $debug;
	  # A parent might have moved with the whole subtree.
	  # So we need to loop up until we get to a base.
	  # else, it might be a regular MID - check below.
	}
      }
    }
    

    if (!$URL) {
      # No HyperNews ID was found.
      # Check MID database to extract URL.
      
      my $middir = &untaintPath(&fliphostname($midhost));
      $midfile = &untaintPath($midfile);

      &HNMsg ("\n middir = $middir\n") if $debug; 
      
      #---Read from MID database
      &HNMsg ("trying to parse \"$hnmidDB/$middir/$midfile\"") 
	if $debug;
      my %urc = &parseURCFile("$hnmidDB/$middir/$midfile,urc");
      
      if ($urc{'Responses'}) {
	$URL = "$urc{'Responses'}.html";
	&HNMsg("Found URL: $URL") if $debug;
      }

    }
  }

 check:
  if ($URL) {
    # Finally, check that the URL exists.
    if (-e "$hndocs$URL,urc") {
      # Check if it has been moved.
      my %urc = &parseURCFile("$hndocs$URL,urc");
      &HNMsg ("\nfound in URC Responses: $urc{'Responses'}\n") if $debug;
      if ($urc{'Moved'}) {
	my $whereto = $urc{'MovedTo'} || $bodyURL;
	if ($whereto) {
	  $URL = $whereto;
	  # Remove ...get prefix.
	  $URL =~ s,.*/get(\.cgi)?/,/,;
	  goto check;  # Check the new URL - should limit depth.
	}
      }
    }
    else {
      # Unknown URL. Maybe we want to add response as orphan
      my $processMsg;  # description of problem
      if ($upmsgid) {
	$processMsg = "The message you are responding to, identified
by <$upmsgid>, is unknown at this time.  If it hasn't arrived yet,
wait a bit and try again.  If it was deleted, you cannot post a reply.";
      } else {
	$processMsg = "The URL $URL
does not exist on this server.  Perhaps it is misspelled.";
      }
      # Just return null URL to allow later processing.
      return (0, $processMsg);  
    }
  
  }
  return ($URL, '');
}


sub ProcessMemberInfo {
  # Check if user is a member
  my ($from, $userName) = @_;
  &HNMsg ("from = \"$from\"
 userName = $userName
 MemberInfo-UserId = $MemberInfo{'UserID'}") if $debug;

  my %MemberInfo = &getMember($from);
  $from ||= $MemberInfo{'UserID'};
  $userName ||= $MemberInfo{'Name'};
  
  return ($from, $userName);
}

