# admin-lib.pl - Administration of message trees.
# Copyright Board of Trustees of the University of Illinois at UC, Feb 1996

# See admin-responses.pl

require "Admin/hnrc";

sub admin_choices {

    local $debug = 0;

    if (@responsesList == 1 && $allowCopytoNewBase) {
	# This feature doesnt work yet, so don't try it.
	$responseBecomesBase = qq{
<INPUT TYPE="radio" NAME="asbaseyesno" VALUE="yes">
If creating a new base article, <strong>use message as base article</strong>. 
<BR>
<INPUT TYPE="radio" NAME="asbaseyesno" VALUE="no" CHECKED>
NO
<P>
};
    }

    print qq{
<HR>

<H2>Message Administration</H2>
};

    if ($moveSF == 0) {
	print qq{
This form allows you to delete one or more messages.
};
    }
    else {
	print qq{
This form allows you to delete, move, or copy one or more messages.
You can move messages by copying and deleting the original.
};
    }

    my $and_replies = 
	qq{ and all replies to those selected messages} if $allowThreads;

    print qq{
<B>The action will be applied to the messages you select above$and_replies.</B>
<P>

<HR>

$whoisthis<P>
};

    # This feature doesnt work yet.
    my $placeholderOption = $allowPlaceholders && qq{
Delete the placeholder after
<SELECT NAME="expires">
<OPTION>now
<OPTION>now + current age
<OPTION>1 day
<OPTION SELECTED>1 week
<OPTION>1 month
<OPTION>eternity
</SELECT>
<P>
};

    if (!$authenticated && ($manualSecurity || ($deleteSF == 1))) {
	$emailid = " or email address" if $allowEmailUserID;
	    print qq{
<STRONG>$UserIDorHandle</STRONG> (nickname$emailid):<BR>
<INPUT TYPE="text" NAME="UserID" SIZE=35 MAXLENGTH=65
       VALUE="$remoteUser"><p>

<STRONG>Password at $hnSystemName</STRONG>: <BR>
<INPUT NAME="Password" TYPE="password" SIZE=8 MAXLENGTH=8>
<P>
<HR>
};
	}
	else {
	    print qq{
<INPUT NAME="remoteUser" TYPE=hidden VALUE="$remoteUser"> <P>
<INPUT NAME="adminPassword" TYPE=hidden VALUE="$remotePassword"> <P>
};
	}

#After submitting: <BR>
#<INPUT TYPE="radio" NAME="next" VALUE="source" CHECKED> Go back to Source <BR>
#<INPUT TYPE="radio" NAME="next" VALUE="destination"> Go on to Destination <BR>

    if ($moveSF > 0) {
	print qq{

If you want to <STRONG>copy or move</STRONG> messages, specify the
HyperNews path of a destination forum or message that all messages
will be copied or moved to.  The destination must already exist, so
maybe create it first. <P>

<STRONG>Path of Destination (a Forum or Message)</STRONG>: (e.g. "test") <BR>
<INPUT NAME="DESTINATION" SIZE=60 MAXLENGTH=60> <p>
<P>

$responseBecomesBase

<INPUT TYPE="radio" NAME="notifyyesno" VALUE="yes">
<strong>Notify Subscribers</strong> at destination <BR>
<INPUT TYPE="radio" NAME="notifyyesno" VALUE="no" CHECKED>
NO

<P>
<HR>
};
    }

    if ($moveSF == 0) {
	# Don't show delete option if there is no other option.
	print qq{
<INPUT TYPE="hidden" NAME="deleteyesno" VALUE="yes" CHECKED>
};
    }
    else {
	print qq{
If you want to <STRONG>delete</STRONG> messages (the default), specify
that here.  If you want to <B>move</B> messages, you need to delete
the original messages; placeholders will be left pointing to where
they were moved. <P>

<INPUT TYPE="radio" NAME="deleteyesno" VALUE="yes" CHECKED>
<strong>Delete Messages</strong> <BR>
<INPUT TYPE="radio" NAME="deleteyesno" VALUE="no">
NO

<p>

$placeholderOption

<HR>

<STRONG>Caution</STRONG>: After <strong>delete</strong>ing messages
 (the default), if you have not copied them (i.e. no destination above),
then the selected messages are not be recoverable. <P> 
};
    }

}


#		my $do_what = '';
#		if ($deleteSF > 0) {
#		    $do_what = 'Delete';
#		    $do_what .= ' or Move' if ($moveSF > 0);
#		}
#		else {
#		    $do_what .= 'Move' if ($moveSF > 0);
#		}
#		#Select messages to $do_what.   $repliesIncluded 

1;
