#!/usr/local/bin/perl
# annotations-lib.pl
# Copyright Board of Trustees of the University of Illinois at UC, April 1995
 
sub ann_errors {
    # Replace this with HNError, unless there is a reason to return codes.
    local($code, $format)=@_;
    local ($msg);
    if ($code==200) {
	$msg="200 AN Ok";
    } elsif ($code==201) {
	$msg="201 AN No annotations";
    } elsif ($code==400){
	$msg="400 AN Bad request";
    } elsif ($code==401){
	$msg="401 AN URL out of range"; 
    } elsif ($code==402) {
	$msg="402 AN Access denied";
    } else {
	$msg="500 AN Server error";
    }

    if ($Annformat && $Annformat == 'list') {
      print "Content-Type: text/plain\n\n";
    }
    else {
      &print_Content_type();
      printf("<!-- version=%s -->\n", "NCSA_FORMAT_COOKIE_HTML");
      printf("<!-- status=%s -->\n", $msg);
    }
}

 
sub convert_annotation {
    local($tmpget)=$getURL;
    $anndebug=0;
    $getURL = $an_getURL;
    &HNMsg ("
 
      Showing Msg Info!!!!!
      Query Info is: $query 
      Command is: $cmd
      Url is: $url
      Urn is: $urn
      Date_min: $date_min
      Date_max: $date_max
      User_list: $user_list 
      Max: $max
      Format: $format
      Setname: $setname
      if comp is:$an_getURL
  ") if $anndebug;

    local($relative_path) = $url;
    if ($url =~ m,$hnbinURL/$an_getURL,) {
	$relative_path = $url;
	$relative_path =~ s,$hnbinURL,$an_getURL,;
    } else {
	$relative_path =~ s,://,/,;
	$relative_path = "/$relative_path";
    }
    &HNMsg ("Relative Path is: $relative_path<p>") if $anndebug;
    &HNMsg ("hnget is $getURL<p>") if $anndebug;
    %in = &parseURCFile("$hndocs$relative_path,urc");
    $responses = $in{'Responses'};
    $base = $in{'BaseURL'};
    &HNMsg("Base URL is:$base <p> Responses is:$responses<p>") if $anndebug;
    if ($base) {
	&ann_errors(200,"html");
        $outlineDepth = -1;
	&printResponsesTree(1);
	$getURL=$tmpget;
    } else {
	&ann_errors(201,"html");
    }
}

sub viewAnnotation{
    local($tmpget)=$getURL;
    local($anndebug) = 0;
    $getURL = $an_getURL;
    &HNMsg ("Viewing Annotation now!!!") if $anndebug;
    if (!$anmethod) {
	&printHEAD();
    }
    #if ($headerText) { print $headerText; }
    &HNMsg ("Annotation Method is $anmethod\n") if $anndebug; 
    if ($base ne $articleURL) {
    	&printHeaderLines();
    }
    else {
    	$baseTitle = $title;
    }
    &HNMsg ("\$getURL is $getURL\n") if $anndebug;
    &printBody();

    &printEnd();
    $getURL=$tmpget;
}

sub AddAnnotation{
    if (!$remoteUser) {
	$remoteUser=$address;
    }
    $articleURL = $url;
    $virtualPath = $relativePath;
    $title = "Base Annotation Document for $url";
    $upTitle="";
    $upURL="";
    open (DFILE, $domain_file);
    local(@domain) = <DFILE>;
    close(DFILE);
    local($accessOK)=0;
    foreach $location (@domain) {
	#&HNMsg ("Location is $location \n");
	chop($location);
	if ($url =~ /^$location/) {
	    #&HNMsg ("Inside Loop\n") if $anndebug;
	    $accessOK = 1;
	}
    }
    #if (!$accessOK) {
#	&HNMsg ("Annotation Post failed\n");
#	&HNMsg ("No Permission to Post from $url\n");
#	&ann_errors(402,"html"); 
#	return(); 
#    }
    if ($url=~ /$an_getURL/) {
	$virtualPath=$url;
	$virtualPath=~ s|$an_getURL||;
    } elsif
	(! -e "$hndocs$virtualPath,urc") {
	    #&HNMsg ("Creating Base Annotation here\n") if $anndebug;
	    &AddArticle(1);
	}
    &AddingAnnotationResponse();
}

sub AddingAnnotationResponse {
    #&HNMsg ("Adding Annotation Response\n");
    if ($annbody) {
	$responseFile = "hn_tmp$$";
	open(RESPONSE, ">$hndocs/$responseFile");
	print RESPONSE "$annbody";
	close RESPONSE;
	#&HNMsg ("Address is $address\n") if $anndebug;
	#setting parameters to call AddResponse
	$body = $responseFile;
	$contentType = "HTML";
	$title = $anntitle;
	#Address is previously set
	if ($address) {
	    local (%member) = &getMember($userid);
	    $newuserid = $member{'UserID'};
	    $newuserName = $member{'Name'};
	    $newuserURL = $member{'UserURL'};

	    if ($newuserid) {
		$userName = $newuserName;
		$userURL = $newuserURL;
	    }
	}

	#UserName and UserURL are previously set
	#UpRel, and title are previously set
	#&HNMsg ("virtualPath is: $virtualPath\n") if $anndebug;
	$URL = $virtualPath;
	%in = &parseURCFile("$hndocs$URL,urc");
	$base = $in{"BaseURL"}; 
	$responses = $in {"Responses"};
	my %response = ();
	&AddResponse('notify', 0, %response);
	&ann_errors(200,"html");


#  print "Content-type: text/html\n\n\n
#
#      Annotation Added!!!!
#      Showing Msg Info!!!!!<p>
#      Query Info is: $query <p>
#      Command is: $cmd  <p>
#      Url is: $URL <p>
#      relativePath is:  $virtualPath <p>
#      email is: $address <p>
#      user name: $userName <p>
#      body = $annbody <p>
#  ";
    } else {
        #&HNMsg ("Redirecting Here\n");
	print "Location: $editResponseURL$virtualPath?Annotation

Adding Annotation 
<A HREF=\"$editResponseURL$vitualPath?Annotation\">
$editResponse$virtualPath";
    }
}

1;
