#!/usr/bin/perl
# batch-fetch-pop-mail.pl
# Fetch mail via a POP3 server and post to HyperNews.

# Originally from Jamie Wilson <jbrw@yahoo.com>
# Added command line options using Getopt::Declare.

# This is alpha software.  Please use with caution and 
# let me know about any problems or fixes. (liberte@hypernews.org)

BEGIN {
    # Prepend HyperNews directories to load path.
    $0 =~ m{^(.*)/[^/]+$ }x;   $hnbin = $1 || '.';
    $hnbin =~ s{/(.scripts|Admin|SECURED)}{}g;
    unshift(@INC, $hnbin, "$hnbin/.scripts"); 
    # Append HyperNews modules to load path.
    push (@INC, "$hnbin/.scripts/lib");
}

use Getopt::Declare;
use Mail::POP3Client;

require "Admin/hnrc";

local $plaintext = 1;

$debug = 1;

####################################
# Option variables - default values

$::forum = '';
$::user = '';
$::password = '';
$::pophost = '';

####################################

&feval('&BatchMainPL()');


sub BatchMainPL {

    # Command line args:

    ##################################################################
  my $optctl = q{
	--forum <directory>	Directory of forum.
	{ $::form{responses} = $directory; }
	--dir <directory>	[ditto]

	--user <login>		Login of POP account
	{ $::user = $login; }

	--password <string>	Password of POP account
	{ $::password = $string; }

	--host <server>		POP server
	{ $::pophost = $server; }

	--quiet			No output.
	{ $::debug = 0; }
};
  
    $args = new Getopt::Declare($optctl);

    ##################################################################


    my $forum_option = "-f $forum" if $forum;

    my $pop = new Mail::POP3Client($user, $password, $pophost);
    my $i;

    for ($i = 1; $i <= $pop->Count; $i++) {
        my $msg = $pop->HeadAndBody($i);
        open PIPE, "|$hnbin/mail-incoming.pl $forum_option";
        print PIPE $msg;
        close PIPE;
        $pop->Delete($i);
    }

    $pop->Close;

    exit;
}
