#!/usr/bin/perl
# batch-rebuild-outline.pl - clear the outlines in all subdirs of a forum.
# Copyright HyperNews.org, 1998

# Written by Daniel LaLiberte for HyperNews.org.


###########################################################

# We have to do some things with @INC in order for this to compile right.
BEGIN 
{
    # Prepend HyperNews directories to load path.
    $0 =~ m{^(.*)/[^/]+$ }x;   $hnbin = $1 || '.';
    $hnbin =~ s{/(.scripts|Admin|SECURED)}{}g;
    unshift(@INC, $hnbin, "$hnbin/.scripts"); 
}

require "Admin/hnrc";

local $plaintext = 1;

# For debugging, we leave files HNbatch.out and HNbatch.old in /tmp.
$debug = 1;
if (0 && $debug) {
  rename "/tmp/HNbatch.out", "/tmp/HNbatch.old";
  open(DEBUG, ">/tmp/HNbatch.out");

  # Redirect STDOUT and STDERR to DEBUG
  open(SAVEERR, ">&STDERR");
  open(STDERR, ">&DEBUG") || die "Cant dup DEBUG";
#  open(STDOUT, ">&DEBUG") || die "Cant dup DEBUG";

  select(STDERR); $| = 1;     # make unbuffered
#  select(STDOUT);  $| = 1;     # make unbuffered
  select(DEBUG);  $| = 1;	 # make unbuffered

  $debugHandle = "main::DEBUG";
}

require 'add-lib.pl';

&feval('&BatchMainPL()');



sub BatchMainPL {

    use  Getopt::Std;
    getopt('F', \%opts);

    # Get the forum name to operate on.
    my $forum = $opts{F};

    require "urc.pl";
    require 'response-lib.pl';

    print ("Rebuilding message outline for $forum\n\n") if $debug;

    &clear_message_outline_recursively($forum);
}


sub clear_message_outline_recursively {
    my ($dir) = @_;
    local $debug = 1;
    # Recursively call clearResponseList starting from dir.
    print ("Rebuilding $dir\n") if $debug; 
    {
	local $debug = 0;
	&clearResponseList($dir);
    }

    opendir (DIR, "$hndocs$dir");
    my @files = readdir DIR;
    closedir DIR;

    my $file;
    foreach $file (@files) {
	if ($file !~ m{^\.}) {
#	    print ("File: '$file'\n") if $debug;
	    $file = &untaintPath($file);
	    if (-d "$hndocs$dir/$file" && !-l "$hndocs$dir/$file" &&
		-f "$hndocs$dir/$file/responses.html") {  # Nothing to clear.
#		print ("Is Directory...\n") if $debug;
		&clear_message_outline_recursively("$dir/$file"); 
	    }
	}
    }
}
