#!/usr/bin/perl -T
# edit-article.pl - generates a form for writing an article, or forum.
# Copyright Board of Trustees of the University of Illinois at UC, April 1995

# Add current directory to load path.
$0 = $ENV{SCRIPT_FILENAME} if $0 =~ m{^/dev};
$0 =~ m{^(.*)/[^/]+$ }x;   $hnbin = $1 || '.';
unshift(@INC, $hnbin, "$hnbin/.scripts"); 

# Uncomment these lines if you have problems getting any output.
#print "Content-type: text/html\n\n";
#print "0: $0\n";

#print "INC: @INC\n";

require "Admin/hnrc";
&feval('&editArticlePL()');

sub editArticlePL {

    require "urc.pl";
    require "member-lib.pl";
    require 'formlib.pl';
    my %form = &GetFormArgs();

    local $debug = 0;

    # Possibly via login.
    &checkAuthenticated('', '', $form{UserID}, $form{Password});


    $URL = $ENV{'PATH_INFO'};

    my $thisURL = &URLencode($ENV{REQUEST_URI} || 
			     "$editResponseURL$URL");
    my $thisUserID = "userid=$remoteUser" if $remoteUser;
    my $redirectURL = "$loginURL?$thisUserID&url=$thisURL";

    my $isAdmin = $authenticated && &isAdmin($remoteUser, $base);
    $whoisthis = &sustring($remoteUser);
    if ($whoisthis) { 
	$whoisthis = qq{
This forum will be owned by $UserIDorHandle:
'<STRONG>$remoteUser</STRONG>'.};
	if ($manualSecurity) {
	    $whoisthis .= qq{
If you wish to use a different $UserIDorHandle, you\'ll need to
 <A HREF="$redirectURL">login</A> again.
};
        }
	$whoisthis .= "<P>";
    }

    local $debug = 0;

    my $path = $ENV{PATH_INFO};
    my $urcFileURL = "$hndocs$path,urc";
    my %urc;
    &HNMsg ("urcFileURL is $urcFileURL\n") if $debug;

    if ($path) {
	# Check path chars
	$path = &untaintPath($path);
	# &debugvar('path', $path);

	# Path should include .html.
	if ($path !~ m,\.html$,) {
	    $path .= '.html';
	}

	# Make sure it does not include response numbers.
	if ($path =~ m,/[0-9]+\.html$,) {
	    &HNUserError("Don't edit a message as if it were a forum.");
	}

	#&debugvar('path', $path);

	if ($path) {
	    # Get the urc for $path.
	    %urc = &parseURCFile($urcFileURL);
	    # process information from URC file and -body.html 
	    &getBaseContent(%urc);
	}
    }

    $userid = $remoteUser || $originalOwner;
    if (!$remoteUser) {
	$remoteUser = "UnknownUser";
    }
    $originalOwner ||= $userid;

    if ($manualSecurity == 0) {
	# Should not test for access yet if manual security is set
	# because there is no way to have entered a password.

	if ($path && (-e "$hndocs$path,urc") && ($addArticleSF > 1)) {
	    # The Article exists already.
	    &HNMsg ("Forum URC:$hndocs$path.html,urc
Owner: $originalOwner\n") if $debug;

	    &access1($addArticleSF, 2, $originalOwner, $remoteUser,
		     qq{Forum already exists, owned by 
 "<strong>$originalOwner</strong>".
  <strong> $remoteUser </strong> can\'t overwrite!},
	 $authenticated, $base);
	}
	else {
	    # Need to also check parent forum.

	    # For now just check whether remoteUser can create a forum.
	    &access1($addArticleSF, 2, $userid, $remoteUser, 
		     "User <strong> $remoteUser </strong> 
is not permitted to create a forum.<p>", 
		     $authenticated);
	}
	
    }


    &print_HTML_HEAD("Edit a Forum on $hnSystemName");

    print qq{
<H2> Edit a Forum at $hnSystemName</H2>

<FORM ACTION="$addArticleURL" METHOD="POST">
$whoisthis
};

    print qq{
<STRONG>Owner $UserIDorHandle:  </STRONG>  (Owner must be a member.) <BR>
<INPUT TYPE="text" NAME="UserID" SIZE=35 MAXLENGTH=65 
       VALUE="$originalOwner"><p>
};

    
    if (!$authenticated) {
	if ($addArticleSF == 2) { $theOwner = "the Owner or"; }

	print qq{
 (If you are $theOwner an Administrator making changes for the Owner) <BR>
<STRONG>UserID</STRONG>: <BR>
<INPUT NAME="remoteUser" SIZE=35 MAXLENGTH=65> <P>
 
<STRONG>Password at $hnSystemName</STRONG>: <BR>
<INPUT NAME="Password" TYPE="password" SIZE=8 MAXLENGTH=8> <P>

<HR>
};
    }
    else {
	# Pass these through to reauthenticate.  Maybe only if manual.
	print qq{
<INPUT NAME="remoteUser" TYPE="hidden" VALUE="$remoteUser">
<INPUT NAME="adminPassword" TYPE=hidden VALUE="$remotePassword">
};
    }

    if ($allowModeration) {
  
	if ($moderation eq "yes" | $moderation eq "Yes") {
	    $moderationYes = "checked";
	} else {
	    $moderationNo = "checked";
	}
  
	$moderationOption = qq{
<STRONG> Will this page be moderated?</STRONG>
<INPUT TYPE="radio" NAME="moderation" VALUE="yes" $moderationYes> Yes
<INPUT TYPE="radio" NAME="moderation" VALUE="no" $moderationNo> No
<BR>
};
}

    # For NNTP interface - not done yet.
    if ($allowNNTP) {
	$nntpInformation = qq{
<strong>NNTP subscription</strong>
 (To subscribe need to fill the following box)<br>
 Newsgroups:  <INPUT TYPE="text" NAME="newsgroups" size=40 ><BR>

 NNTP Server: <INPUT TYPE="text" NAME="nntp" VALUE="news.cso.uiuc.edu" >

 Frequency: <select name=frequency>
    <option $selected>2
    <option >8
    <option >12
    <option >24
 </select> Hours<BR>
 };
    }


    if ($allMemberForums eq 'some') {
	my %sam = ();
	if (!$urc{Subscribe}) {
	    $urc{Subscribe} = ($defaultSubscribeAll ? 'all' : 'no');
	}
	$sam{$urc{Subscribe}} = 'CHECKED';

	$subscribeOption = qq{
<STRONG> Is this an All-Member Forum?</STRONG>
<INPUT TYPE="radio" NAME="subscribe" VALUE="yes" $sam{all}> Yes
<INPUT TYPE="radio" NAME="subscribe" VALUE="no" $sam{no}> No
<BR>
};
    }
    else {
	# Pass the current value through, if any.
	$subscribeOption = qq{
<INPUT TYPE=hidden NAME="subscribe" VALUE=$urc{Subscribe}>
};
    }

    $searchOption = qq{
<STRONG>URL for Search Form</strong>:<BR>
 (If specified, a search button linked to this URL 
will be available on every page in the forum.)<BR>
<INPUT TYPE="text" NAME="searchURL" size=60 maxlength=120><BR>
};

    my %contentTypeOption;

    $contentType ||= 'Smart Text';
    $contentTypeOption{$contentType} = 'CHECKED';

    $formatOption = qq{
<STRONG>Choose a Format for your Forum Message:</STRONG> <BR>

<DL>

<DD> <INPUT TYPE="radio" NAME="contentType" VALUE="Smart Text"
 $contentTypeOption{'Smart Text'}>

 <B>Smart Text</B>: $hnSystemName will wrap lines in paragraphs separated
 by blank lines.  Paragraphs containing any lines starting with space or
 tab are not formatted, so don\'t indent your paragraphs.  Adjacent lines
 starting with the same prefix are not formatted.  URLs and
 email addresses will be made into links.

<DD> <INPUT TYPE="radio" NAME="contentType" VALUE="Word Processor"
 $contentTypeOption{'Word Processor'}>

 <B>Word Processor</B>: $hnSystemName will wrap long lines, break lines at
 hard Returns, preserve leading blanks and tabs, and use a
 fixed-width font.   URLs and email addresses will be made into links.

<DD> <INPUT TYPE="radio" NAME="contentType" VALUE="Plain Text"
 $contentTypeOption{'Plain Text'}>

 <B>Plain Text</B>: $hnSystemName will not change your formatting.
 Be sure to break up your lines with Returns.
 
<DD> <INPUT TYPE="radio" NAME="contentType" VALUE="HTML"
 $contentTypeOption{HTML}>
 <B>HTML</B>: Enter any HyperText that goes between &lt;BODY&gt;
 and &lt;/BODY&gt;

<DD> <INPUT TYPE="radio" NAME="contentType" VALUE="URL"
 $contentTypeOption{URL}>

 <B>URL</B>: Enter only an http URL or path.  A path may be absolute
 (e.g. /some/doc.html, starting at $hndocs) or relative
 (e.g. doc.html).  A relative path is relative to the <i>parent</i> of
the forum directory you specified above, so drop the last component of
the directory.  The document must be formatted in HTML and must be
readable by your server.

</DL>
};

    print qq{

<STRONG>Title of Forum: </STRONG> <BR>
<INPUT NAME="title" SIZE=60 MAXLENGTH=120 VALUE="$title"> <P>

<STRONG>Short Title: </STRONG> 
 (used in references; if null, Title is used.) <BR>
<INPUT NAME="short_title" SIZE=60 MAXLENGTH=120 VALUE="$short_title"> <P>


<!--
<STRONG>Short Description: </STRONG> 
 (used in longer references) <BR>
<TEXTAREA NAME="description" ROWS=3 COLS=62 WRAP="SOFT">$description</TEXTAREA>
<P>
-->

<STRONG>Directory: </STRONG> <BR>

 (This is the relative path of the directory where messages in this
 forum will be stored, relative to your hypernews document root,
<tt>"$hndocs"</tt>. e.g. <tt>"test"</tt>.  The URL for the resulting
forum will be <tt>"$getURL/&lt;dir&gt;.html"</tt>.  Leading and
trailing '/' are optional.  Directory component names must begin with
a non-digit.)  <BR>

<INPUT NAME="responses" VALUE="$responses" SIZE=60 MAXLENGTH=120> <P>

<STRONG>Email List Address: </STRONG> <BR>

 (This is an optional address to which people can email their messages
for this forum via mail-incoming.pl.  If you don\'t specify this
address, $mail_to is used. This address will also be used as the
sender of messages instead of $mail_sender.  If you do specify an
address, say 'mylist\@mydomain', make sure mylist exists, perhaps by
adding it to your system aliases file.  You should also create an
owner for the list called Owner-mylist and an address for
administrative requests called mylist-request.  Although HyperNews
does not yet use these, users and some systems rely on this
convention.) <BR>

<INPUT NAME="ListAddress" VALUE="$listAddress" SIZE=60 MAXLENGTH=120> <P>

$nntpInformation<P>

$moderationOption<P>

$formatOption<P>

<STRONG> Forum Message
</STRONG> <BR>

 (The Forum Message will be displayed at the top level of the forum.
Enter text or a URL here using the appropriate format selected above.)  <BR>


<TEXTAREA NAME="body" ROWS=25 COLS=62 WRAP="SOFT">$body</TEXTAREA>
<P>

<STRONG>Body Tag:</STRONG> <BR>

 (The Body Tag is used instead of &lt;BODY&gt; on each page of the forum.
If you leave this blank, a body tag is inherited from a parent forum, or
the global default.) <BR>

<TEXTAREA NAME ="bodytag" ROWS=3 COLS=60>$local_body_tag</TEXTAREA>
<P>

<STRONG>Header: </STRONG> <BR>

 (The Header is displayed at the top of every page in the forum after
 the Body Tag.  Subforums of this forum also inherit this header, by default. 
If you leave this blank, a header is inherited from a parent forum, or
the global default used if it is specified in the HyperNews
configuration file.  You can use any HTML text, or a URL;
see the URL Format for the Forum Message for constraints on the URL. ) <BR>

<TEXTAREA NAME="headerURL" ROWS=3 COLS=60>$local_header</TEXTAREA>
<P>
 
 
<STRONG>Footer: </STRONG> <BR>

 (Like the Header, the Footer is displayed at the <em>bottom</em> of every page
in the forum. ) <BR>

<TEXTAREA NAME="footerURL" ROWS=3 COLS=60>$local_footer</TEXTAREA>
<P>




<STRONG> Default Message Outline Depth</STRONG> 
 (global default is $globalDefaultOutlineDepth.  Use "-1" for All):

 <INPUT NAME="defaultOutlineDepth" VALUE="$defaultOutlineDepth" 
 SIZE=2  MAXLENGTH=20>
<P>

$subscribeOption<P>

$searchOption<P>

<HR>

<INPUT TYPE="submit" VALUE="Create (or update) Forum"> <P>

</FORM>

};

    &printEnd();
}


sub getBaseContent {
    my (%urc) = @_;
    # Assign to a mess of global vars with info in the %urc.

    local($debug) = 0;

    $base = $urc{'BaseURL'};  # Should be same as URL

    $title = $urc{'Title'};
    &HNMsg ("title is $title") if $debug;

    $short_title = $urc{'ShortTitle'};

    $description = $urc{'Description'};

    #$upTitle = $urc{'UpTitle'};
    #$upURL = $urc{'UpURL'};  # Assumed to be null

    $responses = $urc{'Responses'};
    &HNMsg ("responses is $responses") if $debug;

    $listAddress = $urc{'ListAddress'};

    $local_body_tag = $urc{'BodyTag'};
    $local_header = $urc{'HeaderURL'};
    $local_footer = $urc{'FooterURL'};

    $moderation = $urc{'Moderation'};
    &HNMsg(" moderation of this page is: $moderation") if $debug;

    $originalOwner = $urc{'From'};
    $userName = $urc{'Name'};
    $userURL = $urc{'UserURL'};

    $defaultOutlineDepth = $urc{'DefaultOutlineDepth'};
    #&HNMsg("DefaultOutlineDepth is: $defaultOutlineDepth");

    $searchURL = $urc{'searchURL'};
    #&HNMsg("searchURL is: $searchURL");

    $body = $urc{'Body'};
    $contentType = $urc{'ContentType'};

    if (!$contentType && $body =~ m,^(\w+:)|/,) {
      # This is an older article with no contentType.
      if ($body !~ m,($responses(-body|-content)\.html)$,) {
	# Don't allow editing of other than -body (or -content) files.
	my $file = $1;
	if (!-e "$hndocs$file" || -d "$hndocs$file") {
	  $file = '';  # Give it up
	}
	if (!$file) {
	  $contentType = 'URL';
	}
      }
    }

    $contentType ||= ($body && 'HTML');

    &HNMsg ("contentType is $contentType") if $debug;
    &HNMsg ("body is $body") if $debug;

    # Checking whether $contentType is URL.
    if ($contentType ne 'URL') {

      # It's not a URL, so go find XXX-body.html and decode it.
	local(@bodyLines);
	
	$bodyFile = "$responses-body.html";
	open (BODY, "<$hndocs$bodyFile");
	@bodyLines = <BODY>;
	close BODY;

	local($bodypart) = "";
	if ($contentType eq "Smart Text") {
	  $body = join("", @bodyLines);
	  $body =~ s,<PRE>|</PRE>,,gi;
	  $body =~ s,<P>|</P>,,g;
	  # Remove anchors.
	  $body =~ s{<A HREF=\"[^\"]+\">([^<]+)</A>}{$1}gix;
	  $body = &unescapeHTML($body);
 	}
	# Need unconverter for Word Processing format.
	elsif ($contentType eq "HTML") {
	  $body = join("", @bodyLines);
	  $body = &unescapeHTML($body);
	}
	elsif ($contentType eq "Plain Text"){
	  $body = join("", @bodyLines);
	  $body =~ s,<PRE>|</PRE>,,ig;
	  $body = &unescapeHTML($body);    
	}
      }
}


sub unescapeHTML {
  my ($string) = @_;
  
  $string =~ s/^\s*//;		# delete leading space
  $string =~ s/\&lt;/</g ;
  $string =~ s/\&gt;/>/g ;
  # $string =~ s/\&quot;/\"/g ; don't undo what wasnt done.
  # Dont quote double quotes.  
  $string =~ s/\&amp;/\&/g ;	# do this last.
  $string;
}


