#!/usr/bin/perl -T
# edit-subscribe.pl - edit user's subscriptions to mailing list.
# Copyright Board of Trustees of the University of Illinois at UC, April 1995

# This is used via a URL like:
#  http://www.hypernews.org/HyperNews/edit-subscribe.pl/base.html?userid

# Add current directory to load path.
$0 = $ENV{SCRIPT_FILENAME} if $0 =~ m{^/dev};
$0 =~ m{^(.*)/[^/]+$ }x;   $hnbin = $1 || '.';
unshift(@INC, $hnbin, "$hnbin/.scripts"); 

require "Admin/hnrc";
&feval('&editSubscribePL()');

sub editSubscribePL {
    require "urc.pl";
    require "formlib.pl";
    require "subscribe-lib.pl";
    require "member-lib.pl";
    require "edit-lib.pl";

    my %form = &GetFormArgs();

    local $debug = 0;

    &printAssoc('form', %form) if $debug;

    &checkAuthenticated($form{UserID}, $form{Password},
			$form{remoteUser}, $form{adminPassword});

    # Form userid overrides, for purposes of whose subscription to show.
    $userid = $form{UserID} || $ENV{QUERY_STRING} || $remoteUser;
    $userid = &useridOf($userid);
    $identifier = &identifierOf($userid);
    my %member = &getMember($userid);
    &printAssoc("Member", %member) if $debug;

    # Authentication required only if userid is also a member.
    # my ... ($authenticateInquiries && %member);

    &HNMsg("UserID: '$userid'") if $debug;
    &HNMsg("Authenticate: '$authenticateInquiries'") if $debug;

    
    # Try setting remote user one more time.
    # Need this for opt auth. when affected user is member.
    $remoteUser ||= $userid;  


    # Determine what the forum or message is.
    &HNMsg("PATH_INFO $ENV{PATH_INFO}") if $debug;
    my $URL = $ENV{PATH_INFO};
    # $URL = $form{URL} || $URL;  not for this form.

    # &print_HTML_HEAD("Subscribe or Unsubscribe");

    my %urc = &parseURCFile("$hndocs$URL,urc");
    $base = "$urc{BaseURL}";

    &print_HTML_HEAD("Subscribe or Unsubscribe");

    my $isAdmin = $authenticated && &isAdmin($remoteUser, $base);
    my $whoisthis = &sustring($remoteUser);
    if ($whoisthis) { $whoisthis = "You are: $whoisthis"; }

#    my $thisURL = &URLencode($ENV{REQUEST_URI} || 
#			     "$editSubscribeURL?$userid");
#    my $redirectURL = "$loginURL?userid=$userid&url=$thisURL";

    # Special access check for inquiries.
    if ($authenticateInquiries && %member) {
	&access1(2, 2, $userid, $remoteUser,
 "'<b>$remoteUser<b>' can't inquire about subscription of '<b>$userid</b>'",
			 $authenticated, $base);

	$inquireMsg = qq{
To "<B>Inquire about</B>" an existing subscription, enter a $UserIDorHandle or
Email address here and then go to the bottom of the form and select Do It. <P>
};
    }

    my $changed;

#The following arrays hold the information to change the User Info.
#FtmpURL - Holds the URLS.
#FFlag - Holds the subscription type (Subscribed/Unsubscribed).
#FInheritance - Identifies Inheritance Type.
#FChange - Identifies to what the string is supposed to change.
    my (@FtmpURL, @FFlag, @FInheritance, @FChange);

    local $debug = 0;

    &printAssoc("The URC", %urc) if $debug;


      if ($defaultNotification) {
        $autoSubscribe = qq{
You are automatically subscribed if you are the author of a message,
if you left the "Notify me" box checked.
};
      }

    &printAssoc('form', %form) if $debug;

    my $joinMsg;
    if ($joinSF == 1 && !$authenticated) {
	$joinMsg = qq{
If you are a frequent contributor to these forums, you should
<A HREF="$editMemberURL">become a member</A>.  
};
    }

    my $memberMsg = qq{
Note that subscription is different from membership or registration.
Subscription applies to only one forum or thread at a time whereas
your membership info is available in all forums of $hnSystemName.
$joinMsg
If you are already
a member, you can <A HREF="$SECUREDeditMemberURL?$userid">edit
your member info</A>, including your email address.
<P>
};

    print qq{
 <H2>Subscribe or Unsubscribe</A> </H2>

The subscription/notification feature makes it easy for you to follow
discussions you are particularly interested in.  $hnSystemName can
notify you by email whenever someone adds a message or replies to
something you want to follow.  To enable this notification feature,
select "<B>Subscribe</b>" in the following form.  
$autoSubscribe <P>

Each email that you get will contain the URL of the message, along
with the whole message.  You can use that URL to view the message on
the web, and from that page, you can then select the Email button,
and "<B>Unsubscribe</B>" to stop receiving email.
<P>

$memberMsg

};


    if ($ENV{'REQUEST_METHOD'} eq 'POST') {
	# ... being called as an action.


    $changeOrInquire = $form{'command'};
    &HNMsg("changeOrInquire: '$changeOrInquire'") if $debug;
    if ($form{commandcheckbox} eq 'change') {
	$changeOrInquire = 'Submit Changes';
    }


	#Here goes the count of the depth
	$count = $form{'depth'};

	if (!&useridOK($userid)) {
	    # Could just &HNError here.
	    $errstr = "<STRONG>Invalid $UserIDorHandle or Email Address</STRONG><P>";
	}
	else {

	    if ($changeOrInquire eq "Submit Changes") {
		# The user is changing his subscription
		&HNMsg("remoteUser: $remoteUser") if $debug;
		&HNMsg("remotePassword: $remotePassword") if $debug;

		# We could check this:
		# if (($changeOrInquire ne "Inquire") || 
		#    $authenticateInquiries)

		&access1($notifySF, 2, $userid, $remoteUser,
 "'<b>$remoteUser<b>' can't change subscription of '<b>$userid</b>'",
			 $authenticated, $base);

		# The following loop generates the array to change the
		# subscription...  by reading the appropiate fields
		# from the form.

		for ($i = 0; $i < $count; $i++) {
		    $FtmpURL[$i] = &untaintPath($form {"TMPURL$i"});
		    $FFlag[$i] = $form {"TYPE$i"};
		    #chop($FFlag[$i]);
		    $FInheritance[$i] = $form {"INH$i"};
		    &HNMsg ("\$FInh[$i] is $FInheritance[$i]\n") 
			if $debug;
		    $FChange[$i] = $form {"subscribe$i"};
		}

		# Make the changes.
		for ($i = 0; $i < $count; $i++) {
		    #&HNMsg ("$FtmpURL[$i], $userid, $FChange[$i]") 
		    #  if $debug;
		    if ($FChange[$i] eq "Not Specified") {
			&replaceSubscription($FtmpURL[$i], $userid);
		    } 
		    if ($FChange[$i] eq "Subscribe") {
			&replaceSubscription($FtmpURL[$i], $userid,
					     "Immediate");
		    }
		    if ($FChange[$i] eq "Unsubscribe") {
			&replaceSubscription($FtmpURL[$i], $userid, 
					     "Unsubscribe");
		    }
		}
		print "<P><STRONG>Your subscription has been changed!</STRONG>
 Make more changes below.<P>";
	    }
	}
    }

    if ($joinSF > 0 && !$authenticated) {  #  || !$remotePassword
	# if ($notifySF == 2) { $orMember = "or Member"; }
	$inquirePasswordMsg = 
	    qq{(required to Change, not to Inquire)} if 
		!$authenticateInquiries;

	$passwordline = qq{
<P>
<STRONG>Password at $hnSystemName</STRONG> (if you are a member): <BR>
<INPUT NAME="Password" TYPE="password" SIZE=8 MAXLENGTH=8> 
 $inquirePasswordMsg <P>
};


	$adminline = qq{
<HR>
<P> (Ignore the rest unless you are an Administrator $orMember making changes for the User) <P>
 <STRONG>Administrator $orMember</STRONG>: <BR>
 <INPUT NAME="remoteUser" SIZE=35 MAXLENGTH=65> <P>

 <STRONG>Admin $orMember Password</STRONG>: <BR>
 <INPUT NAME="adminPassword" TYPE="password" SIZE=8 MAXLENGTH=8> 
};

    }
    else {
	$passwordline = qq{
<INPUT NAME="remoteUser" TYPE=hidden VALUE="$remoteUser">
<INPUT NAME="adminPassword" TYPE=hidden VALUE="$remotePassword">
};  
    }

    my $tmpUrl = $URL;
    $tmpUrl =~ s,\.html$,,;
    my (@tmpURL, @Userid, @Flag, @Frequency, @Inheritance);
    my $count = 0;

    my $tmpUpUrl;
    do {
	$tmpURL[$count] = $tmpUrl;
	($Userid[$count], 
	 $Flag[$count], 
	 $Frequency[$count], 
	 $Inheritance[$count]) = &getSubscription($tmpUrl, $userid);

	my %urc = &parseURCFile("$hndocs$tmpUrl.html,urc");
	$tmpUpUrl = $urc{'UpURL'};
	$tmpUrl =~ s,/[^/]*$,,;
	&HNMsg ("\$tmpUrl is $tmpUrl \n\$tmpUpUrl is $tmpUpUrl\n") if $debug;

	$count++;
    } while($tmpUpUrl);


    my $size;
    $tmpUrl = @tmpURL[$count-1];
    $tmpUrl =~ s/\.html$//;
    $tmpUrl .= "/";

    for ($size = $count-1; $size >= 0;$size--) {
        &HNMsg("Loop # $size") if $debug;
	$tmpUrl = @tmpURL[$size];
	my %urc = &parseURCFile("$hndocs$tmpUrl.html,urc");
	my $tmptitle = $urc {'Title'} || "(Untitled)";
	my $tmpauthor = $urc {'From'};
	my %authorInfo = &getMember($tmpauthor);
	#my $authorUserID = &useridOf($tmpauthor);
	#my $authorEmail = &addressOf($tmpauthor);
        #my $hideEmailAddress = 
        #   $hideEmailAddresses || $authorInfo{Hide} eq 'Email';

	my $author = &identifierOf($tmpauthor) ||
		$authorInfo{Name} || 'Author Not Shown';

        # Ignore author on forum itself.  hacky way to do this though.
        $authorString = "($author)" if ($size != $count-1);

        $subscriptions .=  qq{

Replies to:
<A HREF = "$getURL$tmpUrl.html">
$tmptitle</A> $authorString <br>
<INPUT TYPE="hidden" NAME="TMPURL$size" VALUE="@tmpURL[$size]">
<INPUT TYPE="hidden" NAME="TYPE$size" VALUE="@Flag[$size]">
<INPUT TYPE="hidden" NAME="INH$size" VALUE="@Inheritance[$size]">
};

	&HNMsg("Inheritance[$size]: $Inheritance[$size]") if $debug;
	&HNMsg("Flag[$size]: $Flag[$size]") if $debug;
	if ($Inheritance[$size] eq "Not Specified") { 
	    $currently = "Not Specified"; 
	    # Inherit at the base-article level is confusing - remove it.
	    #if ($size == ($count-1)) {
	    # $currently = "Unsubscribe";
	    # &HNMsg("Unsubscribed instead") if $debug;
	    #}
        }

	elsif ($Flag[$size] =~ m/Immediate/)
	{ $currently = "Subscribe"; }
	else 
	{ $currently = "Unsubscribe"; }

        &HNMsg("tmpauthor=\"$tmpauthor\", userid = \"$userid\"") if $debug;   
	if ((($tmpauthor ne $userid) || !$tmpauthor) 
            #&& ($size != ($count-1))
	   ) {
	    @inheritPossible = ("Not Specified");
	}
	else {
	    @inheritPossible = ();
	}
	if ($userid) { 
	    my $currented = $currently;
	    $currented .= 'd' if ($currently ne 'Not Specified');
	    $currentMsg = "(now: <B>$currented</B>)"; 
	}
        &HNMsg("currently = $currently") if $debug;
	$subscriptions .= "\n <SELECT NAME=\"subscribe$size\">" .
	    &buildOptions($currently,
			  'Subscribe', 'Unsubscribe', @inheritPossible) .
			      "\n</SELECT> $currentMsg";
        
        #&HNMsg("<text>$subscriptions</text>") if $debug;

	$subscriptions .= "<HR>";

	$tmpUrl =~ s/[^\/]*$//;
	$tmpUrl =~ s/\/$//;
	$tmpUrl .= ".html";
    }

    $subscriptions .= "<INPUT TYPE=\"hidden\" NAME=\"depth\" VALUE=\"$count\">";

    if ($userid) {
	$subscriptions = " \n(Current subscription for <strong>$identifier</strong> in parens.) <P>
 $subscriptions";
    }


    if ($joinSF > 0 && !$authenticated) {
	$submitControls = qq{
<INPUT TYPE="radio" NAME="command" VALUE="Inquire" CHECKED>
Inquire about $UserIDorHandle
<INPUT TYPE="radio" NAME="command" VALUE="Submit Changes">
Submit Changes

<INPUT TYPE="submit" NAME="commandsubmit" VALUE="Do It"> <P>
};
}
    else {
	$submitControls = qq{
<INPUT TYPE="submit" NAME="command" VALUE="Submit Changes"> <P>
};
    }


    #############################################3

    print qq{
$whoisthis<P>

$inquireMsg

<HR>

<FORM ACTION="$editSubscribeURL$URL" METHOD="POST">
};

    if (!$authenticated || $isAdmin) {
	$or_email_id = " or Email Address" if ($allowEmailUserID ||
						 $notifySF == 1);
	# Non-member subscribers might use email directly.

	print qq{
<STRONG> $UserIDorHandle$or_email_id</STRONG>:<BR>
<INPUT NAME="UserID" SIZE=35 MAXLENGTH=65 VALUE="$userid"> <P>

$errstr

If you want to change your subscription, first enter your $UserIDorHandle
or Email address above.  You will also need to enter your password below, and
select "Submit Changes".   <P>

$passwordline
};
    }
    else {
	print qq{
<INPUT NAME="UserID" TYPE=hidden VALUE="$userid">
};
	# include remoteUser and remotePassword too??
    }

    print qq{

You may see several levels of choices below.  The forum is
first.  The rest, if any, are for each of the messages and replies in
the chain down to whatever you were reading when you clicked on
"Subscribe".  Select <b>Subscribe</b> or <b>Unsubscribe</b> at any
level.  If <b>Not Specified</b>, the selection at the next level up
will be used instead.  <P>

<HR>

$subscriptions 
<P>

$submitControls

<!--
<INPUT TYPE="submit" NAME="command" VALUE="Submit Changes"> 

You may need to select this to submit your changes properly:
<INPUT TYPE="checkbox" NAME="commandcheckbox" VALUE="change"> <P>
-->

<P>

$adminline
</FORM>
};

  print qq{
<H3> 
| 
<A HREF="$instructionsURL#Notify">
Help for $hnSystemName $hnversion</A>
| </H3>
} if $instructionsURL;

  &printEnd();
}

