
# Called by 'get' to continue the process if we need to generate the
# whole display.  It might use frames, embed, or hnview.

sub getMore {
    require "member-lib.pl";

    local $debug = $debug || 0;

    # Check for automatic redirect.
    if ($urc{'Redirect'}) {
      $qsOfFrame = "?frame=$frameOption" if $frameOption;
      # We should also include TargetWindow.
      print "Location: $urc{'Redirect'}$qsOfFrame\n\n";
      exit;
    }

    # Attempt to recover from broken URL.
    my ($tmpURL) = $URL;
    while (!$articleURL) {
	# Chop off last component and try again.
	$tmpURL =~ s,/[^/]*$,,;
	if (!$tmpURL) {
	    # If all else fails...
	    if (-e "$hndocs$hnRootDoc,urc") {
		&brokenURL("$getURL$hnRootDoc");
	    }
	    elsif ($hnRootDoc) {
		&brokenURL($hnRootDoc);
	    }
	    &brokenURL();
	}
	$tmpURL .= ".html";
	if (-e "$hndocs$tmpURL,urc") {
	  # Could do automatic redirect to here.
	  &brokenURL("$getURL$tmpURL");
	}
    }

    # Choose framed or unframed display
    if ($frameset) {
	&print_Content_type();

	$baseFrameURL = $URL;
	$baseFrameURL =~ s,.html$,,;

	# Use the same title as for the base frame.
	print <<"FRAME_END";
<HTML>
<HEAD> <TITLE>$title</TITLE> </HEAD>

<FRAMESET ROWS = "*,60%">

  <FRAMESET COLS = "40%, 60%">
     <FRAME SRC = "$getURL$URL?frame=base$aqsOfAdmin" 
         NAME="baseFrame" MARGINWIDTH="20 "> 
     <FRAME SRC = "$getURL$URL?frame=outline&baseFrame=$baseFrameURL$aqsOfAdmin" 
         NAME="outlineFrame" SCROLLING="yes"> 
  </FRAMESET>

  <FRAME SRC = "$getURL$URL?frame=empty" NAME="responseFrame">

<NOFRAMES> 
<h1 align=center><blink>Frame ALERT!</blink></h1> 
<p> 
This document is designed to be viewed using 
Frame features. If you are seeing this message, you are using 
a frame <i>challenged</i> browser. 
</p> 

<p> 
A <b>Frame-capable</b> browser can be gotten from 
<a href="http://home.netscape.com/">Netscape Communications</a>. 
</p> 

<p>
To see the page without frames use:

<pre>
  <A HREF="$getURL$URL">$getURL$URL</A>
</pre>
</NOFRAMES> 

</FRAMESET>

</HTML>
FRAME_END

	exit;
    }
    elsif ($emptyFrame) {  
	&print_HTML_HEAD("Message Frame");

	print "<br><br>";
	print "<center><font size=3>&lt;Message Frame&gt;</font></center>";
	print "</HTML>";

	&printEnd();
	exit;
    }

    #==========================================
    # Normal display.

    require "hnview.pl";

#    require "member-lib.pl";
#    local (%member) = &getMember($userid);
#    $newUserID = $member{'UserID'};  
#    $emailAddress =  $member{'Email'};

# Could check whether remoteUser is admin, which is boring.
# Do this check for response visibility.
# We could check whether remoteUser is allowed to read a particular page,
# if/when we have per page security.
# Also need to check whether user is permitted, when $adminOption is set.

 
    # get information from base article    
    $baseURL = &getBaseURL($URL);
    %baseArticle = &parseURCFile("$hndocs$baseURL.html,urc");

    &access1($hnReadSF, 4, '', $remoteUser,
	     "No permission to read forum or message",
	     $authenticated, $baseURL);

    &HNMsg("baseURL:$hndocs$baseURL.html,urc\n") if $debug;

    # Does the remote user have visibility?
    $VisibleTest = $urc{'Visibility'};
    if ($allowModeration) {
	$showInvisible = &moderatorTest($remoteUser, $authenticated, 
					$hnReadSF, $baseURL);
    } else {
	$showInvisible = &visibleTest();
    }
    # $showInvisible = 1;  This should not be set by default.
    &HNMsg("showInvisible: $showInvisible\n") if $debug;

    &getDepthDefaults();

    my (%urc) = &parseURCFile("$hndocs$URL,urc");

    # Display the message, which might actually be a forum.
    # Use either inline or outline display.
    if ($inlineDepth && $inlineDepth ne '0') {
	require "embed";
	&HNMsg ("Inlining: $inlineDepth\n") if $debug;
	&viewEmbeddedArticle($inlineDepth, %urc);
    } else {
	&HNMsg ("Outlining: $outlineDepth\n") if $debug;
	&viewArticle();
    }

}


sub brokenURL {
    my ($tryURL) = @_;

    my $badURL = $ENV{PATH_INFO};
    $badURL .= "?$ENV{QUERY_STRING}" if $ENV{QUERY_STRING};

    &print_HTML_HEAD("$hnSystemName URL Broken");

    print <<EOT;
<H2>$hnSystemName URL Broken</H2>

Something is wrong with the URL you entered, which was:
<PRE>
 $getURL$badURL
</PRE>

Either you (or someone else) typed it in wrong, or the
forum or message it refers to has been moved or deleted.
EOT

    if ($tryURL) {
	print <<EOT;
Instead, please try the following URL:
<PRE>
 <A HREF=\"$tryURL\">$tryURL</A> <P>
</PRE>
EOT
    }

    &printEnd();
    exit;
}


1;
