#!/usr/local/bin/perl
# hnview.pl - View a HyperNews article or response.
# Copyright Board of Trustees of the University of Illinois at UC, April 1995

require "urc.pl";
require "wwwdates.pl";
require 'hnview-lib.pl';

# Some variables to control formatting.
if (0 && $ENV{'HTTP_USER_AGENT'} =~ m|^Mozilla|) {
    $TABLE = '<TABLE>';
    $endTABLE = '</TABLE>';
    $TR = '<TR>';
    $endTR = '</TR>';
    $TD = '<TD>';
    $endTD = '</TD>';
}
else {
    $TABLE = '';
    $endTABLE = '';
    $TR = '';
    $endTR = ' <BR>';
    $TD = ' <NOBR>[ ';
    $endTD = ' ]</NOBR>&nbsp; ';
}

    if (0 && $gifsOK) {
      $TABLE = '';
      $endTABLE = '';
      $TR = '';
      $endTR = '<BR>';
      $TD = '';
      $endTD = '';
    }

$B = '<STRONG>';
$endB = '</STRONG>';
$B = '';
$endB = '';



sub viewArticle {
  # Generate a view of a forum or message.

  &frameVariables() if ($rFrame || $bFrame || $oFrame);
  
  &printHEAD();

  # &HNMsg("hnbinURL: $hnbinURL");
  
  if ($base ne $articleURL) {
    &printThreadLinks() if (!$oFrame && $allowThreads);
    if ($allowModeration) {
      #	    &printVisibility();# if $showInvisible;
      # Not ready yet.
    }
    &printHeaderLines($plaintext) if (!$oFrame);
  }
  
  &printBody() if (!$oFrame);
    
  print '<P>';
  if ($base ne $articleURL) {
    &printThreadLinks() if (!$oFrame && $allowThreads);
  }
  else {
    print "\n<P><HR SIZE=5>\n" if (!$oFrame);
  }

  if ($ButtonsBeforeMessages || $reverseMessages) {
      &printButtons();
  }

  if ($adminOption) {
      &HNMsg("qsOfFrame in responseTree: $qsOfFrame\n") if $debug;
      my $qs = &appendToQS('', # "baseFrame=$baseFrameURL", 
			   $qsOfFrame, 'admin', $qsofnogifs);
      print qq{
 <FORM ACTION="$adminResponsesURL$URL$qs" METHOD=POST $target>
};

      print qq{
 <INPUT TYPE="checkbox" NAME="response" VALUE="$URL">
 Select this message: <A HREF="$getURL$URL">$title</A>
} if ($base ne $articleURL);
  }


  ######################################
  # &printDateSelectors();

  my $replies_exist = &printResponsesTree() if (!$moved && !$bFrame);
  ######################################


  if ($adminOption) {
      require 'admin-lib.pl';
		
      &admin_choices();

      print qq{
<P>
<INPUT TYPE="submit" VALUE="Submit">

</FORM>
}; 
  }



  if (!$ButtonsBeforeMessages && 
      ($replies_exist || !$reverseMessages)) {
      &printButtons();
  }
  
  &printEnd();
}


sub printButtons {
    print $startButtons;
    if ($closed) {
      print '<B>This forum is closed.</B><p>';
    }
    else {
      &printAddLink()  if (!$moved && !$bFrame);
    }
    &printCommandLinks();
    print $endButtons;
}


sub printHEAD {
    # Print the HTML head and start the body.

    my $otherHead = '';

    $otherHead .= qq{
<LINK rel="owner" href="mailto:$address">
} if $address;

    if (!$supportCaching && $disableCaching) {
	# Further disable caching by clients.   No guarentees.
	# This would force a reload also when you go back and forward,
	# which is undesirable during preview.  So don't call this sub.
	$otherHead .= qq{
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="Mon, 01 Jan 1990 00:00:01 GMT">
};
    };

    $otherHead .= qq{<BASE $targetBlank>\n} if $qsOfFrame;

    &print_HTML_HEAD($title, $otherHead);
}


require 'icon-lib.pl';

# $allowThreads = 0;

sub printHeaderLines {
  local ($plaintext, $shortHeaders) = @_;

  # Only use printHeaderLines for responses.  Base articles must
  # provide their own.
  # If plaintext is true, then don't HTMLize things - used for email.
  # If shortHeaders is true, then only print one Re line.

  local $debug = 0;

  $shortHeaders ||= $rFrame; # If showing the message, abbreviate

  local (@ancestors, $nextUpURL, $nextUpPath, $nextUpTitle);
  local($reLine);
  local($userAnchor, $addressAnchor);
  local($address);
  
  # Query string for all headers.
  my $qs = &appendToQS('', $resetFrame, $qsOfAdmin, $qsofnogifs);
  &HNMsg("qsA: '$qsOfAdmin'  qs: '$qs'") if $debug;

  # Title
  if (!$plaintext) {
      print "<H2>" if ($allowThreads);
      print &IconTag($upRel);

      if ($shortHeaders && $allowThreads) {
	  # Link to get to the message by itself.
	  print "<A HREF=\"$getURL$URL$qs\" $targetTop>\n $title</A>\n";
      }
      else {
	  print $title . "&nbsp;";
      }
      print "</H2>" if ($allowThreads);
      print "\n\n";
  }

  if (!$plaintext && $allowThreads) {
    print "<DL> <DD>\n";
    # print "<TABLE BORDER=3><TR><TD>\n";  # See </TABLE> below.
    print "<NOBR>\n";
  }
  
  $nextUpURL = $upURL;
  @ancestors = ();

  # Remove the $getURL from the front of the URLs.
  $nextUpPath = &url2hnpath($nextUpURL);
  my $basePath = &url2hnpath($base);
  &HNMsg ("basePath is $basePath\n") if $debug;
  &HNMsg ("nextUpPath is:$nextUpPath\n") if $debug;

  if ($shortHeaders) {
      if ($nextUpPath && ($basePath ne $nextUpPath)) {
	  my %urc = &parseURCFile("$hndocs$nextUpPath,urc");
	  $reLine = &getTitleAuthor("Re", $nextUpPath, $plaintext, %urc);
	  push(@ancestors, $reLine) if ($allowThreads);
      }
  }
  else {
    # Find all the ancestor URLs and Titles.
    # Dont do this when called from embed, i.e. $shortHeaders.
    while ($nextUpPath && ($basePath ne $nextUpPath)) { 
      my(%urc) = &parseURCFile("$hndocs$nextUpPath,urc");
      $reLine = &getTitleAuthor("Re", $nextUpPath, $plaintext, %urc);
      push(@ancestors, $reLine);
      
      $nextUpPath = &url2hnpath($urc{'UpURL'});
      &HNMsg ("nextUpPath is:$nextUpPath\n") if $debug;
    }
    
    # Do the base too.
    $nextUpPath = &url2hnpath($base);
    $base = &convertref($base);
    local(%urc) = &parseURCFile("$hndocs$nextUpPath,urc");
    $baseTitle = $urc{'Title'}; # baseTitle is global
    if ($plaintext) {
      my $baseSubject = &unescapeHTML($baseTitle);
      push(@ancestors, "X-HN-Forum: $baseSubject");
    }
    else {
      if (!$displayParents) {
	push(@ancestors, 
	   "<font size=+1><I>Forum:</I> <A HREF=\"$base$qs\" $targetTop>
 $baseTitle</A> </font><BR>\n");
      }
    }
  }

  @ancestors = reverse(@ancestors);

  print join ("\n", @ancestors);

  if ($keywords) {
      if ($plaintext) {
	my $plainKeywords = &unescapeHTML($keywords);
	print "\nKeywords: $plainKeywords";
      }
      else {
	print "\n<I>Keywords:</I> $keywords <BR>";
      }
  }

  if ($showHits && !$plaintext) {
	open (FH, "<$hndocs$URL/.hits"); # it need not exist.
	my $hits = <FH>;
	close FH;
	print "\n<I>Hits:</I> $hits <BR>";
  }

  my $hideEmailAddress = $hideEmailAddresses;

  &HNMsg("userid = $userid") if $debug;
  # Get current info for author.
  if ($userid) {
      # $userid is from the From field of the message.
      local (%member) = &getMember($userid);
      # Do reasonable thing even if $userid is not a member.
      $userid = $member{'UserID'} || $userid;
      $userName = $member{'Name'} || $userName;
      my $email = $member{'Email'};
      $address = $email || $address;

      $hideEmailAddress ||= $member{Hide} eq 'Email';

      if ($viewMembers) {
	  $userURL =  
	  ((!$hideUserIDs && $userid) ? "$viewMemberURL?$userid" :
	   (!$hideEmailAddress && $email) ? "$viewMemberURL?$email" 
	   : '');
	   # was $member{'UserURL'} || $userURL
      }
  }

  if ($userName && $userURL && !$plaintext) {
    $userAnchor = "<A HREF=\"$userURL\" $targetBlank>$userName</A>";
  }
  else {
    my $plainUserName = $userName;
    $plainUserName = &unescapeHTML($plainUserName) if $plaintext;
    $userAnchor = "$plainUserName" if $plainUserName;
  }

# $RealOrganization = $urc{'Organization'} || $urc{'Agency'} || $Agency || $Organization;
  $identifier = &identifierOf($userid);

  if (!$plaintext) {
      # What is $date here?  Bad code! bad!
      $date = &wwwdates::hntime(&wwwdates::get_gmtime($date));

      if ($address && !$hideEmailAddress) {
	  # This is redundant with the identifier, except for non-members.
	  # But this overrides identifier of member, if it exists.
	  $addressAnchor = 
	      "&lt;<A HREF=\"mailto:$address\">$address</A>&gt;";
      }
      elsif ($identifier) {
	  $identifier = 
	      qq{&lt;<A HREF="mailto:$identifier">$identifier</A>&gt;} if
		  &addressOK($identifier);
	  $addressAnchor = "<I>$identifier</I>";
      }
      elsif ($userid && !$hideUserIDs) {
	  # This may never get used.
	  $addressAnchor = "&lt;<I>$userid</I>&gt;";
      }

      if (!$userAnchor && !$addressAnchor) {
	  $userAnchor = "&lt;<I>Anonymous</I>&gt;";
      }

      if (!$allowThreads) {
	  print qq{
 <I> by $userAnchor $addressAnchor, &nbsp; $date </I>
 };
      }
      else {
	  print qq{
<I>Date:</I> $date <BR>
<I>From:</I> $userAnchor $addressAnchor <BR>
};
# <I>Organization:</I> $RealOrganization <BR>

      }
  }

  local $debug = 0;

  # Show body URL if not in this HyperNews system.
  my $path = &url2hnpath($URL);
  $path =~ s,([^/])+.html$,,;  # drop last component.
  my $num = $1;
  &HNMsg("hndocsURL: $hndocsURL") if $debug;
  &HNMsg("path: $path\nnum: $num") if $debug;
  &HNMsg("bodyURL: '$bodyURL'") if $debug;
  &HNMsg("compare to: '$path$num-body.html'") if $debug;
  if (!$plaintext && !$moved &&
      $bodyURL &&
      ($bodyURL !~ m,(($hndocsURL)?$path)?$num-(body|content).html$,) &&
      ($bodyURL !~ m,$hndocsURL/hn_tmp[0-9]+$,))
    {
      my $realBodyURL = $bodyURL;
      if ($bodyURL !~ m,^http:,) {
	if ($bodyURL =~ m,^/,) {
	  $realBodyURL = "$hndocsURL$bodyURL";
	}
	else {
	  $realBodyURL = "$hndocsURL$path$bodyURL";  # relative RUL
	}
      }
      print qq{
<I>Body-URL:</I> 
  <A HREF="$realBodyURL" $targetBlank>$realBodyURL</A> <BR>}; 
    }

  if (!$plaintext && $allowThreads) {
    print "\n</NOBR>";
    # print "</TD></TR></TABLE>\n";
    print "\n</DD> </DL>\n";
    print "\n<P>\n";
  }

}


sub getTitleAuthor {
  local ($header, $file, $plaintext, %urc) = @_;

  local ($title) = $urc{'Title'};
  local ($upRel) = $urc{'UpRel'};

  # Return a string with the title and author of $file.
  my $qs = &appendToQS('', $resetFrame, $qsOfAdmin, $qsofnogifs);

  if (!$title) { $title = "Untitled"; }

  my $result;
  if ($plaintext) {
    if ($upRel eq 'None') { $upRel = ''; }
    if ($upRel) {
      $upRel = "$upRel: ";
    }
    my $subject = &unescapeHTML($title);
    $result .= "X-HN-$header: $upRel$subject";
  }
  else { 
      my $iconTag = &IconTag($upRel) if ($header eq "Re");

      $result .= "\n<I>$header</I>: 
  $iconTag
  <A HREF=\"$getURL$file$qs\" $targetTop>$title</A> "; 
  }

  my $userName = $urc{'Name'};

  # Get current info for author. This seems kind of expensive,
  # but it just doubles the number of urc files read.
  my $userid = $urc{'From'};

  my $hideEmailAddress = $hideEmailAddresses;

  my $email;
  my %member;
  if ($userid) {
      %member = &getMember($userid);
      $userid = $member{UserID};
      $email = $member{Email};
      $hideEmailAddress ||= $member{Hide} eq 'Email';
  }
  $userName = $member{Name} || $urc{Name};

  $userURL =  
      ((!$hideUserIDs && $userid) ? "$viewMemberURL?$userid" :
       (!$hideEmailAddress && $email) ? "$viewMemberURL?$email" 
       : '');
       # was $member{'UserURL'} || $userURL

  if ($userName) {
      if ($userURL && !$plaintext) {
	  $result .= " (<A HREF=\"$userURL\" >$userName</A>)"; 
      }
      else {
	  $result .= " ($userName)"; 
      }
  }

  if (!$plaintext) { $result .= "<BR>\n"; }
  $result;
}


sub printBody {

    if ($deleted) {
	print ("<STRONG>Removed on</STRONG>: $deleted\n"); 
    } 
    elsif ($moved) {
	my $whereto = $urc{'MovedTo'} || $bodyURL;
	if ($whereto) {
	  print "<P><STRONG>Moved to</STRONG>: 
 <A HREF=\"$whereto\">$whereto</A>\n";
	}
	if ($urc{'MovedBy'}) {
	  print "<P><STRONG>Moved by</STRONG>: $urc{'MovedBy'}
 <STRONG>on</STRONG>: $moved\n";
	}
    }
    else {
	if ($referenceURL) {
	    print "<UL>\n <LI> <A HREF=\"$referenceURL\">$title</A>";
	    if ($bodyURL) {
		print " - "; 
	    }
	    &printURL($bodyURL, $responses);
	    print " </LI>\n</UL>";
	}
	else {
	  print $startMsgBodyTag if ($base ne $articleURL);
	  &printURL($bodyURL, $responses);
	  print $endMsgBodyTag if ($base ne $articleURL);
	}
    }
}



# This is not used yet.  It is not even tested.
sub messageListToHTML {
  my ($messageDir,  # The message list directory, relative to $hndocs.
      $input,       # A string used for the file handle - a hack.
      $level,       # How deep are we now?
      $chaining,    # Are we chaining a sequence of 1/1/1/...?
     ) = @_;
  # Generate HTML for message list in $messageDir
  require 'record-lib.pl';

  my ($filename) = "$hndocs/$messageDir/.message-list";;

  if (-e $filename && -z $filename) {
    # Need to rebuild the list.
    require 'response-lib.pl';
    &rebuildMessageList($dir);
  }

  $input++;		# this is a string increment
  unless (open($input, $filename)) {
    &HNMsg ("Can't open $filename: $!\n") if $debug;  # No error.
    return; # nothing to do
  }

  my ($nextline) = <$input>;

  # Read the record descriptor
  my (@fieldNames) = split ('|', $nextline);
  my ($recordName) = shift @fieldNames;  # Should be 'Message' or subclass
  my (%message);
  
  $nextline = <$input>;
  # Worry about chaining later.

  while ($nextline) {
    %message = &makeRecordFromLine($nextline, @fieldNames);
    print &messageMetaToHTML('<DD>', 
			     $message{'Title'}, 
			     $message{'Author'}, 
			     $path, $MorD, 
			     $message{'Date'}
			    );
			     
    if ($message{'NumReplies'} > 0) {
      &messageListToHTML();
    }
  }

}


sub include  {
  local($filename,  # The response file, relative to $hndocs.
	$input,     # A string used for the file handle - a hack.
	$level,     # How deep are we now?
	$chaining,  # Are we chaining a sequence of 1/1/1/...?
	$order,     # Are we sorting by thread, date, author, etc.
       ) = @_;
  # Cat the file processing any #include directives.
  # Also process <date> tags, and filter out responses outside a range.
  # ... and lots of other things.  The response file format needs to
  # be redesigned to make this faster.
  local($debug) = 0;

  # Get the directory of the file in case there are subincludes.
  $filename =~ m,^(.*)/[^/]+,;
  my ($dir) = $1;  # $dir is relative to $hndocs.

  $input++;		# this is a string increment
  unless (open($input, "$hndocs/$filename")) {
    # Could dynamically create responses.html at this time, if needed.
    # But we test whether it exists elsewhere.
    &HNMsg ("Can't open $filename: $!\n") if $debug;  # No error.
    return;
  }

  local ($tmpline, $nextline, $includeOFF);
  local ($date, $seconds); 

  my ($path);  # The hn relative URL.
  my ($author, $MorD);
  my ($title); # The title of each message.

  my ($line, $numResponses);

  $nextline = <$input>; # on its own line.
  if ($nextline =~ m,^#numResponses: ([0-9-]*),) {
      $numResponses = $1;
      if ($numResponses == -1) {
	# Responses file needs to be rebuilt.
	close ($input);
	require 'response-lib.pl';
	&updateResponseList($dir);
	open($input, "$hndocs/$filename") || return;
	$nextline = <$input>; # on its own line.
	$nextline =~ m,^#numResponses: ([0-9-]*),;
	$numResponses = $1;
      }
      $nextline = <$input>;	#skip on by this line.
  }
  if (!$nextline) {
    # Empty file - nothing to do.
    return 1;
  }

  local($indent) = 1;
  if ($numResponses == 1) {
      if ($chaining) {
	  # indent the first time only.
	  $indent = 0;
      }
      $chaining = 1;
  } else {
      $chaining = 0;
  }

  if ($indent && (!$Annformat || $Annformat != 'list')) {
        $level++;
	print "<DD>\n" if ($level > 1);
	print "<DL COMPACT>\n";
  }
  while ($nextline) {
      $line = $nextline;
      $nextline = <$input>;
      if ($annotationsmode) {
	  if ($line =~ /<DT>/) {
	      #$tmpline = $line;
	      #$tmpline =~ s/[0-9]+\.//; 
	      $line = "<DT>";
	  } elsif ($line =~ /<DD>/) {
	      $line = "$tmpline$line";
	      $tmpline = "";
	  }
      }


      # Deal with all the previous forms of response lines.
      if ($line =~ m|^<DT>|) {
	  $responseNum = '';
	  if ($line =~ m,([0-9]+\.)$,) {
	      $responseNum = $1;
	      #&HNMsg("found number $responseNum");
	  }
	  my $prefix = $`;
	  if ($prefix =~ m,<A HREF=\"[^\">]*/$get(/[^\">]*)\">,) {
	      $lineprefix = $&;
	  }
	  next; # dont print yet.
      }
      elsif ($line =~ m|^</DT>|) {
	  # Drop these
	  next;
      }
      elsif ($line =~ m|^</?D[LD]>|) {
	  # Drop these
	  next;
      }

      elsif ($line =~ m|^#include "([^/]*)/(.*)"|) {
	 my $includedir = $1;
	 my $includefile = $2;
	 if ($includeOFF) {
	     $includeOFF = 0;
	     next;
	 } else {
	     if ($annotationsmode) {
	       if ($annotationsmode == 1) {$annotationsmode = 2;} 
	       if ($parentinclude) {
		 &include("$dir/$includedir/$includefile", $input, $level, $order);
	       }
	     } else  {
	       # &HNMsg("file: $hndocs$dir/$includefile");
	       if (-e "$hndocs$dir/$includedir/$includefile") {
		 if ($level < $outlineDepth || $outlineDepth < 0) {
		   &include("$dir/$includedir/$includefile", $input, 
			    $level, $chaining, $order);
		 } else {
		   # We have to stop here 
		   # even though chaining might display more.
		   # Display NumMessages below this point.
		   my %urc = &parseURCFile("$hndocs$dir/$includedir.html,urc");
		   print "<DD>...\n";
		   if ($urc{NumMessages} > 0) {
		     print " $urc{NumMessages} Message(s)\n";
		   }
		    # else (!defined $urc{NumMessages}
		    #       || $urc{NumMessages} == 0) 
		   print &newIconHTML
		       (&wwwdates::get_gmtime($urc{LastMessageDate}));
		 }
	       }
	     }
	     next;
	 }
      } else { 
#	  if ($line =~ /<Invisible>/) {
#	      if (!$showInvisible) {
#		  # User can't read this response
#		  $includeOFF = 1;
#		  &HNMsg("include here: $includeOFF\n") if $debug;
#		  next;
#	      } else {
#		  $line =~ s,<Invisible>,(<strong>Invisible</strong>),;
#	      }
#	  }

	  $line = $lineprefix . $line;

	  # Move image outside of anchor.  - for older versions of HN.
	  if ($line =~ s,<IMG[^>]*>,,) {
	      $image = $&;
	      $image =~ m,ALT=\"([^\"]*)\",i;
	      my $altText = $1;
		  
	      if ($gifsOK) {
		  # Regenerate the icon URL
		  my $rel = $altText;
		  chop $rel;
		  $image = &IconTag($rel);
              }
              else  {
		#if ($altText) {
		  $image = $altText;  # Just use the alt text.
		  $image = '' if ($altText eq 'None:');
		#}
	      }
	  }

	  # The anchor might be confused with author home URL anchor.
	  # So test that it is a HN get URL.  This is a hack for now.
	  #&HNMsg("line: $line");
 	  if ($line =~ m,<A HREF=\"[^\">]*/get(\.cgi)?(/[^\">]*)\">([^<]*),) {
	      # Make URL of anchor use URL of document
	      $path = $2;
	      $title = $3 || 'Untitled';
	      #&HNMsg("path: $path");
	      local($anchor);
	      if ($bFrame || $rFrame || $oFrame) {
		my $qs = &appendToQS('', 'frame=response',
				     # "baseFrame=$baseFrameURL",
				     $qsOfAdmin, $qsofnogifs);
		  $anchor = "<A $targetR HREF=\"$getURL$path$qs\">";
	      } elsif ($annotationsmode) {
		  $anchor = "<A TARGET=\"AnnotationWindow\" HREF=\"$getURL$path\">";
	      } else {
		my $qs = &appendToQS('', $qsOfAdmin, $qsofnogifs);
		$anchor = "<A HREF=\"$getURL$path$qs\">";
	      }
	      $line =~ s/<A HREF=\"[^\">]*\">/\n$anchor\n/;
	  }
	  if ($line =~ m,(\([^\)]*\))?\s*(\((Moved|Deleted)\))?(<DATE=([^>]+)>(\s*<DD>)?)?\s*$,) {
	      $line = $`; # Everything before this.
	      $author = $1;
	      $MorD = $2;
	      $seconds = &wwwdates::get_gmtime($5);
	      $date = &wwwdates::hntime($seconds);
	      $author =~ s{^\(([^\)]*)\)$ }{$1}x;  # drop parens
	      $author =~ s{^.*>([^<]*)</A>$ }{$1}ix; # Drop anchor.
#	      &HNMsg("author2: '$author'");
	    }

          # Done extracting the data; now print it out.
	  &messageMetaToHTML($line, $title, $author, $path, $MorD, 
			     $date, $seconds);
      }
  }
  close ($input);

  if ($indent && (!$Annformat || $Annformat != 'list')) {
	# print "<HR>\n" if ($level == 1 && $numResponses > 2);
	print "</DL>\n";
	print "</DD>\n" if ($level > 1);
  }
  print "\n";  # for readability.

}


sub messageMetaToHTML {
  # Generate an HTML line from the message metadata.
  my ($line, $title, $author, $path, $MorD, $date, $seconds) = @_;

  if ($Annformat && $Annformat == 'list') {
    if ($author =~ m,<A HREF=\"([^\">]*)\">([^<]*)</A>,) {
      $authorURL = $1;
      $authorName = $2;
    }
    print "title=$title\n";
    print "url=$getURL$path\n";
    print "author=$authorName\n";
    print "date=$date\n";
    print "\n";
  }
  else {
    
    $line .= '<i>';
    $line .= " by $author" if $author;
    $line .= ', ' . $date if ($seconds && $printResponseDate);
    $line .= " $MorD"  if $MorD;
    $line .= '</i>';
    
    if ($annotationsmode) {
      &annotationsMode();
    } else {
	$line .= &newIconHTML($seconds);
    }

    if ($showHits) {
	open (FH, "<$hndocs$path/.hits"); # it need not exist.
	my $hits = <FH>;
	close FH;
	$line .= " ($hits hits)" if $hits;
    }
    
    print "<DT> ";		# <NOBR>
    
    if ($adminOption) {
      print "
 <INPUT TYPE=\"checkbox\" NAME=\"response\" VALUE=\"$path\">\n";
    }
    
    if ($indent) {
      # Dont HR if there are less than 3 levels viewable.
      # Also dont HR if less than 3 responses.
      # Dont HR anyway, since netscape does it wrong.
      # print "<HR>\n" if ($level == 1 && $numResponses > 2);
      print "$responseNum " if $printResponseNum;
    }
    else {
      # We are chaining, so prefix with (_
      print "(_ ";
    }
    print $image; $image = '';
    
    # print $lineprefix;
    $lineprefix = '';
    print "$line ";		# </NOBR>
    print "</DT>\n"; 
  }
}

# Global var $nowSeconds
$nowSeconds = time;
# &wwwdates::wtime(time, 'GMT');
# $today = &get_gmtime($nowSeconds);

$secondsInDay = 3600 * 24;

sub newIconHTML {
    my ($seconds) = @_;
    # If $seconds
    my $timediff = ($nowSeconds - $seconds) / $secondsInDay;
    my ($icon, $alt);
    my $line = '';
    if ($timediff <= $newest) {
	$icon = $newestIcon; $alt = "newest";
    } elsif ($timediff <= $newer) {
	$icon = $newerIcon; $alt = "newer";
    } elsif ($timediff <= $new) {
	$icon = $newIcon; $alt = "new";
    }
    if ($icon) {
	if ($gifsOK) {
	    $line .= "
 <IMG SRC=\"$icon\" ALT=\"$alt\" 
  WIDTH=$newIconXsize HEIGHT=$newIconYsize ALIGN=\"bottom\">";
	}
	else {
	    $line .= " $alt";
	}
    }
    return $line;
}


sub annotationsMode {
  # This should all go away!
    if ($annotationsmode==1) {
	$parentinclude=1;
    }
    local($tmpdatemin) = &datechangeformat($date_min);
    local($tmpdatemax) = &datechangeformat($date_max);
    if (((&datelaterAB($tmpdate,$tmpdatemin)>=0)
	 ||($annotationsmode == 2))
	&&($parentinclude)||!($date_min)){
	if (((&datelaterAB($tmpdatemax,$tmpdate)>=0)
	     ||($annotationsmode == 2))
	    &&($parentinclude)||!($date_max)){
	    $tmpdate = &switchdatemonth($tmpdate);
	    $line =~ s/<DATE=[^>]+>/ $tmpdate/;
	    if (($annotationsmode == 2)&&$max) {
		$annotationsarray[0] .= $line;
		$line = "";
	    } else {
		if ($max < 0) {
		    local($posmax)=($max*-1)-2;
		    @annotationsarray =
			("$line",@annotationsarray[0..$posmax]);
		    $line="";
		} elsif ($max > 0) {
		    if ($count<$max) {
			@annotationsarray =
			    ("$line",@annotationsarray[0..($max-2)]);
		    }
		    $count++;
		    $line="";
		}
	    }
	} else {
	    $parentinclude=0;
	    $line = "";
	}
    } else {
	$parentinclude=0;
	$line = "";
    }
}




sub printReferences {
    $responsesPath = "$hndocs$responses";
    if ($allowReferences) {
	if (!-e "$responsesPath/references.html") {
	    # print "<B><A NAME=\"References\">No References</A></B>\n";
	} else {
	    print "<B><A NAME=\"References\">References</A></B>\n";
	    print "<UL>\n";
	    open (REFS, "<$responsesPath/references.html");
	    while (<REFS>) {
		print $_;
	    }
	    close (REFS);
	    print "</UL>\n";
	}

    }
}


sub printResponsesTree {
  local($showAnnotations, $noControls) = @_;
  $annotationsMode = $showAnnotations;


  my $result = 0;  # Return 1 if any replies exist.

  local($debug) = 0;
  
  local($responsesPath) = "$hndocs$responses";
  &HNMsg("Annotationsmode is $annotationsmode\n,$getURL") if $debug; 
 
  local($Messages) = "Messages";


  if (-e "$responsesPath/responses.html") {  #  || $qsOfFrame
      # Maybe test NumMessages > 0, but it's not always defined.
      if (!$showAnnotations && $allowThreads && !$noControls) {
	print '<P>';
	# print "<NOBR>";
	print "<B><A NAME=\"Messages\">$Messages</A></B>\n";
	&printDisplayControls();
	print " <P>\n";
      }
#      else {
#	  if (!$Annformat || $Annformat != 'list') {
#	    print "<B><A>$hnset Annotations</A></B> <P>\n";
#	  }
#      }

      if ($outlineDepth != 0) {
	  $result = 1;

	  if ($Annformat && $Annformat == 'list') {
	    print "version=ncsa-annotation-format-list-1
status=200 AS Ok
header=Annotations from the NCSA group
overview=http://blah.ncsa.uiuc.edu/group_overview.html

";
	  }
	  else {
	    print "<NOBR>\n";
	  }

	  &HNMsg(qq{
 outlineDepth = $outlineDepth
 &include("$responses/responses.html", 'fh00', 0, 0)
}) if $debug;

          &include("$responses/responses.html", 'fh00', 0, 0, $order);

	  if ($Annformat && $Annformat == 'list') {
	    print "end\n";
	  }
	  else {
	    print "</NOBR>\n";
	  }
      }


      local($count) = 0;
      if ($annotationsmode && $max) {
	  for($count = (@annotationsarray-1); $count >= 0; $count--) {
	      print $annotationsarray[$count];
	  }
      }
  }
  else {
    # Should we say "No ..." at all?
    if (!$annotationsmode) {
       # print "<B><A NAME=\"Responses\">No $Messages</A></B> <P>\n";
    } else {
       print "<B><A NAME=\"Responses\">No Annotations</A></B> <P>\n";
    }
  }
  # print "</NOBR>";


  return $result;
}




sub printDisplayControls {
  print "<NOBR>\n";
  print "<font size=-1>\n";

  &HNMsg("qsOfFrame within DisplayControl:$qsOfFrame\n")if $debug;
  my $qs = &appendToQS('&', $qsOfFrame, $qsOfBaseFrame, $qsOfAdmin, 
		       $qsofnogifs);

    if ($outlineDepth != $defaultOutlineDepth) {
	$outlineArg = "&outline=$outlineDepth";
    }
	
  if ($simpleButtons || !$allowThreads) {
      print qq{
 [ <A HREF="$getURL$URL?$outlineArg$qs" TARGET=$target>
  Show Index</A> ]
  } if $inlineDepth != 0;

      print qq{
 [ <A HREF="$getURL$URL?inline=-1$qs" TARGET=$target>
  Display All</A> ]
  } if $inlineDepth != -1;

  }
  else {
      # not simpleButtons.
      
      my $inline0 = "inline=0" if $defaultInlineDepth != 0;
      my $inline1 = "inline=1" if $defaultInlineDepth != 1;
      my $inlineAll = "inline=-1" if $defaultInlineDepth != -1;

      if (!$oFrame) {
	print "Inline:\n";
	&commandLink("$getURL$URL?$inline0$outlineArg$qs", $target,
		     "Do not inline these messages at all",
		     "Inline0.gif",
		     $depthIconXsize, $depthIconYsize,
		     "0", 1) if $inlineDepth != 0;
	&commandLink("$getURL$URL?$inline1$outlineArg$qs", $target,
		     "Inline just the top level messages - outline the rest",
		     "Inline1.gif", 
		     $depthIconXsize, $depthIconYsize,
		     "1", 1) if $inlineDepth != 1;
	&commandLink("$getURL$URL?$inlineAll$qs", $target,
		     "Inline all messages",
		     "InlineAll.gif", 
		     $depthIconXsize, $depthIconYsize,
		     "All", 1) if $inlineDepth != -1;
    }

    if ($inlineDepth ne '-1' && !$simpleButtons) {
	# Don't show if inlining all.

	if ($inlineDepth != $defaultInlineDepth) {
	    $inlineArg = "&inline=$inlineDepth";
	}
	my $qualifier = ", after inlining" if $inlineDepth != 0;

	#my $outlineMore = ($outlineDepth + 1) || -1;# if depth is -1, keep it.
	#my $outlineLess = ($outlineDepth - 1) || 1; # if depth is 1, keep it.

	my $outline1 = "outline=1" if $defaultOUtlineDepth != 1;
	my $outline2 = "outline=2" if $defaultOUtlineDepth != 2;
	my $outline3 = "outline=3" if $defaultOutlineDepth != 3;
	my $outlineAll = "outline=-1" if $defaultOUtlineDepth != -1;

	print "Outline:\n";
	&commandLink("$getURL$URL?$outline1$inlineArg$qs", $target,
		     "Outline just the following top level messages$qualifier",
		     "Outline1.gif", 
		     $depthIconXsize, $depthIconYsize,
		     "1", 1) if $outlineDepth != 1;
	&commandLink("$getURL$URL?$outline2$inlineArg$qs", $target,
		     "Outline just the following top 2 levels of messages$qualifier",
		     "Outline2.gif", 
		     $depthIconXsize, $depthIconYsize,
		     "2", 1) if $outlineDepth != 2;
	&commandLink("$getURL$URL?$outline3$inlineArg$qs", $target,
		     "Outline just the following top 3 levels of messages$qualifier",
		     "Outline3.gif", 
		     $depthIconXsize, $depthIconYsize,
		     "3", 1) if $outlineDepth != 3;

	&commandLink("$getURL$URL?$outlineAll$inlineArg$qs", $target,
		     "Show outline of all following messages$qualifier",
		     "OutlineAll.gif", 
		     $depthIconXsize, $depthIconYsize,
		     "All", 1) if $outlineDepth >= 0;
    }

}
  print "</font>\n";
  print "</NOBR>\n";

  if ($Allow_Sort_Options) {
    print "Sort By:\n";
    &commandLink("$getURL$URL?how=author$qs", $target,
		 "Sort Responses by Author",
		 "author.gif", 
		 $depthIconXsize, $depthIconYsize,
		 "1", 1) if $in{'how'} ne 'author';
    &commandLink("$getURL$URL?how=title", $target,
		 "Sort Responses by Title",
		 "title.gif", 
		 $depthIconXsize, $depthIconYsize,
		 "2", 1) if $in{'how'} ne 'title';
#    &commandLink("$getURL$URL?how=type", $target,
#		 "Sort Responses by Type",
#		 "type.gif", 
#		 $depthIconXsize, $depthIconYsize,
#		 "3", 1) if $in{'how'} ne 'type';

    &commandLink("$getURL$URL?how=date", $target,
		   "Sort Responses by Date",
		   "date.gif", 
		   $depthIconXsize, $depthIconYsize,
		 "All", 1) if $in{'how'} ne 'date';
  
    &commandLink("$getURL$URL?how=thread", $target,
                   "Sort Responses by Thread",
                   "thread.gif",
                   $depthIconXsize, $depthIconYsize,
                 "All", 1) if $in{'how'} ne 'thread';
  };
}



sub printThreadLinks {
  #=========================
  # Note, this might be in the base frame or response frame.
  # Better name would be printThreadLinks

  my $qs;

  if ($rFrame) {
    $qs = &appendToQS('&', $qsOfFrame);
  } elsif ($bFrame) {
    $qs = &appendToQS('&', $resetFrame);
    $tarGet = $targetTop;
    &HNMsg("target top: $tarGet\n") if $debug;
  }

  $qs = &appendToQS($qs || '&', $qsOfAdmin, $qsofnogifs);
  
  if ($base ne $articleURL &&  $showInvisible) {
    $qs = &appendToQS($qs || '&', 'show=all');
  }
  
  # Test whether we need icons or text?
  # &HNMsg("Accepts: $ENV{'HTTP_ACCEPT'}");
  if ($gifsOK) {
    # Don't put any spaces between the images.
    print "<NOBR>\n";
  }
  else {
    print "$TABLE $TR\n";
  }

  &commandLink("$threadURL$URL?dir=next-in-thread$qs", $tarGet,
	       "Go to first reply, or next available message.", 
	       "in.gif",
               $threadIconXsize, $threadIconYsize,
	       "Next-in-Thread");

  &commandLink("$threadURL$URL?dir=nextResponse$qs", $tarGet,
	       "Skip replies. Go to next message.", 
	       "next.gif", 
               $threadIconXsize, $threadIconYsize,
	       "Next Message");

#  &commandLink("$threadURL$URL?dir=prevResponse$qs", $tarGet,
#	       "Go to previous message.", "prev.gif", 
#               $threadIconXsize, $threadIconYsize,
#	       "Previous Message");

#  &commandLink("$threadURL$URL?dir=nextThread$qs", $tarGet,
#	       "Skip out to next message at higher level", "out.gif", 
#               $threadIconXsize, $threadIconYsize,
#	       "Next Thread");

  if ($gifsOK) {
    print "\n</NOBR><BR>\n";
  }
  else {
    print "$endTR\n";
    print "$endTABLE\n";
  }
}

sub printVisibility {

    print "$TABLE$TR\n";
    if ($VisibleTest eq "Invisible") {
	print "$TD<BLINK>$B 
<A HREF=\"$hnbinURL/SECURED/visible.pl$URL?Visible\">
Make Visible</A>$endB</BLINK>$endTD \n";
    } else {
	# Don't blink this one.
	print "$TD$B
<A HREF=\"$hnbinURL/SECURED/visible.pl$URL?Invisible\">
Make Invisible</A> $endB$endTD \n";
    }

    print "$endTR$endTABLE\n";
    
}

sub printAddLink {

    my $frameURLOption;
    my $frameOption;
    my $frame;
    my $resetFrameAdd;

    if ($qsOfFrame){
	$frameURLOption = "
 <INPUT TYPE=\"hidden\" NAME=\"baseFrame\" VALUE=\"$baseFrameURL\">";

	if ($oFrame){
	    $frame = "outline";
        } elsif ($rFrame){
	    $frame = "response";
	}

	$resetFrameAdd = "?$resetFrame";
	&HNMsg("frame: $frame\n") if $debug;
	$frameOption = "
 <INPUT TYPE=\"hidden\" NAME=\"frame\" VALUE=\"$frame\">";
    }

    # Don't allow adding in admin mode. 
    # ... because browser forgets which messages were selected.
    return if ($adminOption);

    &commandLink("$editResponseURL$URL", $targetBlank,
		 "Go to a form to enter your message",
		 "add.gif", 80, 24,
		 "Add Message");


    if ($allowThreads) {
	print qq{
 to: <NOBR>"<STRONG>$title</STRONG>"</NOBR> 

$frameURLOption
$frameOption
<P>
};
    }

}


sub printCommandLinks {
    # Links to commands.

    &HNMsg("qsOfFrame in CommandLinks:$qsOfFrame\n") if $debug;
    my $qs = &appendToQS('', $qsOfFrame, $qsOfBaseFrame, $qsofnogifs);

    print "\n\n\n ";

    if ($base ne $articleURL) {
      # &printThreadLinks() if !$qsOfFrame;
    }

    print "$TABLE $TR\n";

    # $joinSF && $joinSF < 3
    if (!$oFrame && $joinSF) {
	if ($viewMembers) {
	    &commandLink("$viewMembersURL", $targetBlank,
			 "View list of $hnSystemName members",
			 "members.gif", 
			 $commandIconXsize, $commandIconYsize,
			 "Members");
	}
	else {
	    &commandLink("$editMemberURL", $targetBlank,
			 "Register or Update your $hnSystemName member info",
			 "members.gif", 
			 $commandIconXsize, $commandIconYsize,
			 "Register");
	}
    }

    if (!$oFrame && $notifySF && $hnEmailNotify) {
      &commandLink("$editSubscribeURL$URL", $targetBlank,
		   "Subscribe to be notified by email, or Unsubscribe",
		   "email.gif", 
		   $commandIconXsize, $commandIconYsize,
		   "Subscribe");
    }

    # Could detect $isAdmin, if only admin allowed to use it.  
    # But caching would mess this up.  Should have $showAdmin in hnrc anyway.
    my $showAdmin = 1;
    if ($showAdmin && ($deleteSF || $moveSF)) {

	if (!$bFrame) {
	    my ($helpmsg, $noadminText, $noadminGIF);
	    my $adminGetURL;

	    if (!$adminOption) {
		$qs = &appendToQS($qs, 'admin', $qsofnogifs);
		$helpmsg = "Turn on Admin mode to Delete or Move messages";
		if ($deleteSF == 1 || $moveSF == 1) {
		    $adminGetURL = $getURL;
		}
		else {
		    $adminGetURL = $getURL;
		    # secured get doesnt work yet with $manual_security == 1.
		    # $adminGetURL = $SECUREDgetURL;
		}
	    }
	    else {
		$noadminText = "No ";
		$noadminGIF = "no";
		$helpmsg = "Turn off Admin mode";
		$adminGetURL = $getURL;
	    }
	    &commandLink("$adminGetURL$URL$qs", $target,
			 $helpmsg, 
			 "${noadminGIF}admin.gif",
			 $commandIconXsize, $commandIconYsize,
			 "${noadminText}Admin Mode");
	}
    }

#    if ($base ne $articleURL) {
#	print "$TD$B<A HREF=\"$base\">
#Return to Base</A> $endB$endTD \n";
#    }

    if (!$gifsOK) {
      # Start a new line.
      print "$endTR $endTABLE\n";
      print "$TABLE $TR\n";
    }
    
    if ($allowFrames && !$bFrame && !$rFrame && !$oFrame) {
      &commandLink("$getURL$URL?frame=newset$aqsOfAdmin", '',
		   "Use frames to show messages", 
		   "frames.gif", 
               $commandIconXsize, $commandIconYsize,
		   "Show Frames");
    }

    
    if ($bFrame || $rFrame || $oFrame){
      my $qqsOfAdmin = "?admin" if $adminOption;
      &commandLink("$getURL$URL$qqsOfAdmin", $targetTop,
		   "Turn off frames",
		   "noframes.gif", 
               $commandIconXsize, $commandIconYsize,
		   "No Frames");
    }

    if ($rFrame && !$bFrame) {
      &commandLink("$getURL$URL?frame=newset$aqsOfAdmin", $targetTop,
		   "Use this message for a new base frame",
		   "newbase.gif", 
               $commandIconXsize, $commandIconYsize,
		   "New Base Frame");
    }

    if ($searchURL && !$oFrame) {
      &commandLink("$searchURL", $targetBlank,
		   "Search for Messages",  # Needs to be customizable message.
		   "search.gif", 
               $commandIconXsize, $commandIconYsize,
		   "Search");
    }

    if ($instructionsURL) { #  && !$oFrame && !$rFrame
      &commandLink("$instructionsURL#Reading", $targetBlank,
		   "Help for $hnSystemName $hnversion",
		   "help.gif", 
               $commandIconXsize, $commandIconYsize,
		   "Help for $hnSystemName $hnversion");
    }


    if ($adminOption) {
      # Need a button for this.
      print qq{
<BR>
  [ <A HREF="$editArticleURL$URL">Edit This Forum</A> ]
};
    }

    print "$endTR $endTABLE\n";
}




sub unescapeHTML {
   local($string) = @_;
 
   $string =~ s/^\s*//;  # delete leading space
   $string =~ s/\&lt;/</g ;
   $string =~ s/\&gt;/>/g ;
   $string =~ s/\&quot;/\"/g ;
   # Dont quote double quotes.  
   $string =~ s/\&amp;/\&/g ; # do this last.
   $string;
}


l;
