#!/usr/local/bin/perl
# icon-lib.pl - Code common to icon manipulation.
# Copyright Board of Trustees of the University of Illinois at UC, April 1995

require "urc.pl";

%icons = &parseURCFile($hniconsTable);


sub IconTag {
    my ($rel) = @_;
    my $iconPath = $icons{$rel} || $icons{'Note'}; 
    if ($gifsOK && $useHNIcons) {        
	my $image = <<EOT;
<IMG src="$hniconsURL/$iconPath" ALT="$rel" 
     WIDTH=$relationIconXsize HEIGHT=$relationIconYsize ALIGN="top">
EOT
        return $image;
    }
    else { 
	my $relText = "$rel: " if $rel and $rel ne 'None';
	return $relText;
    }
}


sub buildIconsOptions{
   local($name, @options) =@_;
   local($string, $image);

   local($tmpoption);
   foreach $option (@options) {
     $tmpoption = $option;
     while (length($tmpoption) < 16) {
       $tmpoption .= ".";
     }
     if ($option eq "None") {
       $string .= "$tmpoption\n";
     } else {
       $image = $icons{"$option"};
       $string .= 
   "$tmpoption <IMG align=absbottom border=0 src=\"$hniconsURL/$image\">\n";
     }
   }
   return $string;
}



sub ParseIconsFile {
    local($IconsFile)=@_;
    local(@icons);
    local($counter);
    # This could be cleaned up considerably.
    open(FILE,"$IconsFile");
    @icons = <FILE>;
    close(FILE);
    for ($counter=0; $counter < @icons; $counter++) {
        $icons[$counter] =~ m/^[^:]+/;
        $icons[$counter] = $&;
    }
    return(@icons);
}


1;
