# HN::User::Member.pm - Member module for HyperNews.
# Copyright HyperNews.org 1998 
# Written by Daniel LaLiberte for HyperNews.org.

$VERSION = (qw$Revision: .01 $)[1];

package HN::User::Member;

require HN::User;
@ISA = qw(HN::User);



__END__

=head1 NAME

HN::User::Member - HyperNews member interface

=head1 SYNOPSIS

use HN::User::Member

# Class methods

# Constructors
my $member = new HN::User::Member
	    { 'Email' => 'user@site',
	      'Name' => 'First Last Name',
	      'URL' => 'http://site/user/' };

# Only registered users have a userid and password.
$user -> userid;       # Current user ID of user.
$user -> password;      # The current password, encrypted.
$user -> new_password;  # A new password, not yet the current one.


=head1 DESCRIPTION

The C<HN::User::Member> supports registered users known to
the HyperNews system.  



=cut
