# HN::User.pm - User module for HyperNews.
# Copyright HyperNews.org 1998 
# Written by Daniel LaLiberte for HyperNews.org.

$VERSION = (qw$Revision: .01 $)[1];

package HN::User;


require 5.002;

use strict;
use vars qw(@ISA @EXPORT);
 

__END__

=head1 NAME

HN::User - HyperNews user profile.

=head1 SYNOPSIS

use HN::User

# Class methods
HN::User -> userid_ok($userid);
HN::User -> email_ok($email);

# Constructors
my $user = new HN::User { 'Email' => 'user@site',
			  'Name' => 'First Last Name',
			  'URL' => 'http://site/user/' };

$user -> email;        # Current email address
$user -> name;         # Full name of user.
$user -> personal_URL;   # Home page of the user.

$user -> identifier;   # Displayable identifier for the user.



=head1 DESCRIPTION

The C<HN::User> constructor creates an object representing a user.
The user may be a temporary user known only for the duration of the
current process, or a registered member (see HN::User::Member), in
which case the information is also stored persistently either locally
or remotely.


=cut
