#!/usr/bin/perl -T
# login.pl - provide login form and then redirect to URL.
# Can't redirect a POST, however, so only use with GETs.
# Copyright HyperNews.org, 1998

# This form would be a good place to offer to enable cookies.

# This is used via a URL like:
#  http://www.hypernews.org/HyperNews/login.pl?url=<encoded URL>
# Also, can add "&userid=<userid>"


# Add current directory to load path.
$0 = $ENV{SCRIPT_FILENAME} if $0 =~ m{^/dev};
$0 =~ m{^(.*)/[^/]+$ }x;   $hnbin = $1 || '.';
unshift(@INC, $hnbin, "$hnbin/.scripts"); 


require "Admin/hnrc";

&feval('&Login()');

sub Login {

    local $debug = 0;
 
#    &HNMsg("hndocs: $hndocs");
#    &HNMsg("SCRIPT_NAME: $ENV{SCRIPT_NAME}");
#    &HNMsg("hnprefix: $hnprefix");
#    &HNMsg("hnbinURL: $hnbinURL");

    require "urc.pl";
    require "member-lib.pl";
    require 'formlib.pl';

    my %form = &GetFormArgs();
    my %query = &parseQueryString();

    $userid = $form{UserID} || $query{userid} || $remoteUser;

    my $URL = $form{URL};

    $URL ||= &URLdecode($query{url});
    $URL ||= $ENV{REDIRECT_URL};  # if login is used via ErrorDocument.
    
    my $redirect_URL;
    my $redirect_method = 'POST';

    if ($URL && $ENV{REQUEST_METHOD} eq 'GET') {
	&HNMsg("POST this form to form{URL}, if provided.") if $debug;
	$redirect_URL = $URL;
    }
    else {
	&HNMsg("URL: '$URL'  maybe METHOD eq POST") if $debug;
	$redirect_URL = $loginURL;
	$hiddenURL = qq{<INPUT TYPE="hidden" NAME="URL" VALUE="$URL">};
    }


    &printAssoc('Form', %form) if $debug;
    &HNENV() if $debug;
    &printAssoc("<P>ENV", %ENV) if $debug;

    # This check will cause cookie generation if appropriate.
    # Pass as second set because that will override other authentications.
    &checkAuthenticated('', '', $form{UserID}, $form{Password});
    my $isAdmin = $authenticated && &isAdmin($remoteUser);

#    my $whoami = &sustring($remoteUser);
#    if ($whoami) { $whoami = "You are: $whoami <BR>"; }
#    my $whoisthat;

    my $adminEmail = &addressOf(@hnAdmin[0]) || @hnAdmin[0];


    &HNMsg("userid is '$userid', Remote User is '$remoteUser'") if $debug;

    # Should look at $ENV{REDIRECT_...} vars to support ErrorDocument.


    if (0 && $authenticated && $URL) {
	# Redirect to $URL, but not if it is the login URL.
	# Also, need to prevent indirect loop via redirection to another URL.
	if ($URL !~ m{$loginURL}) {
	    {
		# How do we pass the userid and password to the URL?
		# Server or cookie authentication would work.
		# Manual authentication by itself does not work unless
		# we pass userid and password in the URL.  bad idea.
		# We could *do* a POST here, returning the result..
		# Or cause a form to be POSTed on the browser, with javascript.
		# Or we could POST to that URL instead of back to login.pl,
		# if it accepts the same UserID and Password.  !!
	    }
	    &printRedirect($URL);
	}
    }


    my %member;
    if ($userid) {
	# &HNMsg("Getting New Member info for $userid");
	%member = &getMember($userid);
	&printAssoc('member', %member) if $debug;

	$newUserID = &useridOf($userid);
	#&HNMsg("userid: $userid  newUserID: $newUserID");

	my $memberOrAdmin = "a member";
	if (&isAdmin($userid)) {  # In what group?
	  $memberOrAdmin = "an administrator";
	}
    }


    if ($authenticated) {
      $loginMsg = qq{Welcome, <B>$remoteUser</B>.};
      # What are you doing here?  Maybe login as someone else?
      $loginMsg .= qq{<P>
You can proceed to use member-only functions, 
or login again, perhaps using a different $UserIDorHandle.};
    }

    else {
      if ($form{UserID}) { # was:  && ($form{UserID} ne $remoteUser)
	# Assume this was a previous attempt.
	$loginMsg .= qq{
Your attempt to login as '$form{UserID}' has failed.
};
	$loginMsg .= qq{ 
Perhaps you entered your $UserIDorHandle or Password incorrectly.
} if $form{Password};
	    
	$loginMsg .= qq{ 
Please try again.
};
    }

#	$loginMsg .= qq{
#$hnSystemName doesn\'t know who you are.
#};

      if ($UseCookies eq 'sometimes') {
	if ($remoteUser &&
	    ($ENV{'HTTP_COOKIE'} || $ENV{'COOKIE'})) {
	  my %member = &getMember($remoteUser);
	  
	  if ($member{SessionLength} eq 'none') {
	    $loginMsg .= qq{
Any cookies sent by your browser are being ignored.  You can 
<A HREF="$SECUREDeditMemberURL">change your member information</A> 
to set the "Remember me" option.  };
	  }
	  else {
	    $loginMsg .= qq{ 
Perhaps your $hnSystemName cookie has expired.
};
	  }
	} # cookie sent
      } # never UseCookies
    } # not authenticated.

    $whereTo = " (to '$URL')" if $URL && ($debug || $isAdmin);
    $loginMsg .= qq{
<P>
Please enter your $UserIDorHandle and Password. <P>
};

    my $resetOption;
    if ($resetPasswordSF && !$externalSecurity) {
	$resetOption = qq{
<P>
 If you have a password but cannot remember it, you can };
	if ($resetPasswordSF == 2) { 
	    $resetOption .= 'ask another member to '; }
	elsif ($resetPasswordSF == 3) { 
	    $resetOption .= qq{
ask an administrator 
 (<A HREF="mailto:$adminEmail">$adminEmail</A>) to 
};
	}
   # Doesnt work well if not authenticated:
	$resetOption .=  qq{ reset it to a random password.  
Be sure to mention your $UserIDorHandle and Email address.
 <P> 
};

    } # $resetPasswordSF

    if (!$externalSecurity) {
	$editMemberOption = qq{
To change your $UserIDorHandle or Password, or to cause your brower
to remember your login longer, please <A
HREF="$SECUREDeditMemberURL">edit your membership info</A>.  <P>
};
    }
    
# Each HyperNews site has its own set of members,
# so being a member here does not mean you are a member at other sites.
# and is located at <A HREF="$topURL">$topURL</A>

    if ($instructionsURL) {
	# Please reference the HyperNews site here.
	$introMsg = qq{
<FONT SIZE=-1>
<BLOCKQUOTE>
 Note that this site uses the <A
 HREF="http://www.hypernews.org/"><B>HyperNews</B></A> system (version
 $hnversion).  
 This site is called "<B>$hnSystemName</B>".  The administrator is <A
 HREF="mailto:$adminEmail"><B>$adminEmail</B></A>.
</BLOCKQUOTE>
</FONT>
 }
    }
    else {
	# Please reference the HyperNews site here.
	$introMsg = qq{
<FONT SIZE=-1>
<BLOCKQUOTE>
This site uses the <A HREF="http://www.hypernews.org/"><B>HyperNews</B></A> 
system (version $hnversion).  
</BLOCKQUOTE>
</FONT>
};

# The administrator at this site is 
# <A HREF="mailto:$adminEmail"><B>$adminEmail</B></A>.
    }

    #==========================================

    &print_HTML_HEAD("Login to $hnSystemName");

    $emailid = " (or email address)" if $allowEmailUserID;

    print qq{
 <H2>Login to $hnSystemName</H2>

$loginMsg

<P>
$whoami
$whoisthat

<FORM ACTION="$redirect_URL" METHOD="$redirect_method">

<STRONG> $UserIDorHandle</STRONG>$emailid: <BR>
<INPUT NAME="UserID" SIZE=35 MAXLENGTH=65 VALUE="$userid"> 
<P>


<STRONG>Enter your Current Password at $hnSystemName</STRONG>: <BR>
<INPUT NAME="Password" TYPE="password" SIZE=8 MAXLENGTH=8>
<P>

<INPUT TYPE="submit" VALUE="Login">

$resetOption
$editMemberOption

$hiddenURL

</FORM>

$introMsg

};

    &printEnd();

}
