#!/usr/local/bin/perl
# preview-lib.pl - HyperNews previewing library
# Copyright Board of Trustees of the University of Illinois at UC, April 1995

require "hnview.pl";  # Should this require be here?  It's circular.



sub previewResponse {
    local (%response) = @_;

    local $URL = $response{'URL'};
    $title= $response{'Title'};
    $keywords= $response{'Keywords'};
    $annotationType= $response{'AnnotationType'};
    $contentType= $response{'ContentType'};
    $bodyURL= $response{'Body'};
    $upRel= $response{'UpRel'};
    $base= $response{'BaseURL'};
    $responses= $response{'Responses'};
    $userid= $response{'From'};
    $password = $response{Password};
    $userName= $response{'Name'};
    $messageID = $response{'MessageID'};
    #$messagePath = $response{'Path'};

    $adminPassword = $response{AdminPassword};

    # Check whether gifs should be included in output.
    $gifsOK = $ENV{'HTTP_ACCEPT'} =~ m,(image/gif)|(\*/\*),;

# Need to escape some chars in the title, keywords, and userName. (others?)
# since they come from a user filled form.  We could instead
# think about saving this in a file, just as for the message body.

    local($encodedtitle) = &URLencode($title); 
    $title = &escapeHTML($title);  # For display.

    local($encodedkeywords) = &URLencode($keywords);
    $keywords = &escapeHTML($keywords);

    local($encodeduserName) = &URLencode($userName);
    $userName = &escapeHTML($userName);
    # others?

    &print_HTML_HEAD($title);

#------------------------------------------------------
# Print form to submit.
# The hidden fields could all be saved to a tmp urc file instead.

    if ($ENV{'HTTP_USER_AGENT'} =~ m|^Mozilla/2|) {
      # We really should be checking for frame support,
      # and broken frame support at that. Mozilla 2.x only.
      $frameWarning = "If this appears inside a frame, be sure to only
 do <B>Back in Frame</B> or you may lose the contents of the form
 for editing your message.";
    }

# closer
# To fix this you just have to make a new function that submits the form and
# closes the window, then call that function with an onClick in the button.
# 
# <input type="button" onClick="submitMe(this.form)">
# 
# function submitMe(form)
# {
#  form.submit
#  self.close()
# }

# Form used to have $tarGet 

    print qq{
<FORM ACTION="$addResponseURL$URL?$annotateOrRespond" METHOD="POST" 
 $javascriptCloser>

<INPUT TYPE="hidden" NAME="URL" VALUE="$URL">
<INPUT TYPE="hidden" NAME="title" VALUE="$encodedtitle">
<INPUT TYPE="hidden" NAME="keywords" VALUE="$encodedkeywords">
<INPUT TYPE="hidden" NAME="referenceURL" VALUE="$referenceURL">
<INPUT TYPE="hidden" NAME="annotationType" VALUE="$annotationType">
<INPUT TYPE="hidden" NAME="contentType" VALUE="$contentType">
<INPUT TYPE="hidden" NAME="bodyURL" VALUE="$bodyURL">
<INPUT TYPE="hidden" NAME="upRel" VALUE="$upRel">
<INPUT TYPE="hidden" NAME="userid" VALUE="$userid">
<INPUT TYPE="hidden" NAME="password" VALUE="$password">
<INPUT TYPE="hidden" NAME="userName" VALUE="$encodeduserName">
<INPUT TYPE="hidden" NAME="subscription" VALUE="$notify">
<INPUT TYPE="hidden" NAME="visibility" VALUE="$visible">

<INPUT TYPE="hidden" NAME="remoteUser" VALUE="$remoteUser">
<INPUT TYPE="hidden" NAME="adminPassword" VALUE="$adminPassword">

$frameURLOption
$frameOption

To <strong>Edit</strong> your message, go
<strong><A HREF="javascript:history.go(-1)">Back</A></strong> to the
previous page, change your text, and then preview again.  To
<strong>Cancel</strong>, just don\'t post.  
$frameWarning <P>

When you are ready to Post your message, push the button below.
Posting may take some time, so please be patient.  Please don\'t post
the same message more than once and don\'t reload this preview page.
<P>

<INPUT TYPE="submit" VALUE="Post your $annotationType"> 

</FORM>

};

    # Could be options in hnrc.
    $alarmTag = "<BLINK>";
    $alarmTagEnd = "</BLINK>";

    if ($title eq "Untitled") {
      print "<P><STRONG>
Warning: Title is ${alarmTag}Untitled${alarmTagEnd}.</STRONG>\n";
    }
    if ($remoteUser && !&addressOK($remoteUser) && !&getMember($remoteUser)) {
	print "<P><STRONG>
Warning: \"$remoteUser\" is not a member and not an email address.</STRONG>\n";
	$remoteUser = "";
    }
    if ($address && !&addressOK($address)) {
      print "<P><STRONG>
Warning: Email address \"$address\" is ${alarmTag}malformed${alarmTagEnd}.</STRONG>\n";
    }
    if ($address =~ m|^unknown|) {
      print "<P><STRONG>
Warning: Email address is ${alarmTag}Unknown${alarmTagEnd}.</STRONG>\n";
    }
    my $complainAboutName = 0;
    if ($complainAboutName && !$userName) {
      print "<P><STRONG>
Warning: Name is ${alarmTag}Unknown${alarmTagEnd}.</STRONG>\n";
    }
    print "\n<HR>\n";

    my %urc = (
#	       'URL' => $URL,
	       'AnnotationType' => $annotationType,
	       'Title' => $title,
	       'Keywords' => $keywords,
	       'Body' => $bodyURL,
	       'UpURL' => $URL,
	       'UpRel' => $upRel,
	       'BaseURL' => $base,
#	       'Responses' => ..
	       'From' => $userid,
	       'Name' => $userName,
	       'Date' => $date);

    { 
	local $debug = 0;
	&getDepthDefaults();

	if ($inlineDepth != 0) {
	    require 'embed';
	    &inlineMessage(%urc);
	    &printEnd();
	}
	else {
#	    local $responses = $responses . '/hn_tmp';  # Nothing yet.
#	    &viewArticle();
	    &printHeaderLines($plaintext);
	    &printBody();
	    &printEnd();
	}
    }
}


# was
#    &printHeaderLines();
#    &printBody();
#    &printEnd();



sub URLencode {
   local($string) = @_;
   # Do something like encoding for a FORM.
   # This is missing several things e.g. the '+' stuff.
   $string =~ s/%/%25/g;  # First do this.
   $string =~ s/\"/%22/g;
   $string =~ s/\&/%26/g;
   $string =~ s/</%3c/g;
   $string =~ s/>/%3e/g;
   return($string);
}


1;
