#!/usr/bin/perl -T
# preview-response.pl - Preview a response before adding it.
# Copyright Board of Trustees of the University of Illinois at UC, April 1995

# This is the action for the FORM returned by generate-responder.pl.

# Add current directory to load path.
$0 = $ENV{SCRIPT_FILENAME} if $0 =~ m{^/dev};
$0 =~ m{^(.*)/[^/]+$ }x;   $hnbin = $1 || '.';
unshift(@INC, $hnbin, "$hnbin/.scripts"); 

require "Admin/hnrc";
&feval('&PreviewResponsePL');

sub PreviewResponsePL {

    require "formlib.pl";
    require "urc.pl";
    require "wwwdates.pl";
    require "member-lib.pl";
    require "preview-lib.pl";
    require "add-lib.pl";

    local $debug = 0;

    my %form = &GetFormArgs();

    &check_userid_email($form{UserID}, $form{Email});

    &checkAuthenticated($form{UserID} || $form{Email}, $form{Password}, 
			$form{remoteUser}, $form{adminPassword});

    $annotateOrRespond = $ENV{QUERY_STRING};
    $responseOrReference = $ENV{QUERY_STRING};

    $command = $form{command};  # Preview or Post


    $URL = $form{'URL'};		# of parent.
    $URL ||= $ENV{'PATH_INFO'};  # hidden vars get dropped when form reloaded.
    $upURL = "$getURL$URL";

  if (!$URL || $URL =~ m,^/[0-9],) {
    &HNError('Congratulations! You have been bit by a HyperNews bug. <P>

 For some reason, the message you are trying to post would end up in a "null"
 forum with no name.  I want to find out how this is happening, but as
 of yet, I know of no pattern.  So please provide as much information
 as you can that might be relevant, including the data listed below.
 Mail to <A
 HREF="mailto:liberte\@hypernews.org">liberte\@hypernews.org</A>.  Here
 are a few questions. <P>

<UL>

<LI> Does this occur every time you post?  Have you posted more than once? <P>

<LI> How did you go about replying?  Did you change the URL on the
 edit-response page, or reload the edit-response form, or preview your
 message multiple times, or anything of that nature that you can
 remember? <P>

<LI> What message or forum were you adding your message to? 
 Please give the URL. If you are using Netscape or MSIE, it might be
 <strong><A HREF="javascript:history.go(-2)">here</A></strong>.<P>

<LI> Do you know if there is a proxy between you and the rest of the
world.  It might be interfering with the form data sent in your message. <P>

</UL>

If you provide this information, I can help you
post your message, so your effort will not have been in vain.
Thanks.
 
' . "
<P>The URL is '$URL'<P>
");
  }


    $title = $form{'title'};
    $annotationType = $form{'annotationType'};
    $referenceURL = $form{'referenceURL'}; # might be null
    $keywords = $form{'keywords'};
    $contentType = $form{'contentType'};
    $body = $form{'body'};
    $notify = $form {'notify'};
    $upRel = $form{'UpRel'};
    $frameString = $form{'frameString'};
    $baseFrameURL = $form{'baseFrame'};
    $visible = $form{'visibility'};

    $userName = $form{'UserName'};

    if ($contentType eq 'URL' && $body !~ m,^(http:|/),) {
      &HNUserError("You have selected 'URL' as the format,
 but only full or absolute http URLs are allowed.");
    }

    if ($frameString eq "outline"){
	$tarGet = "TARGET=\"outlineFrame\"";
    }
    elsif ($frameString eq "response"){
	$tarGet = "TARGET=\"responseFrame\"";
    }

   if ($frameString){
	$frameURLOption = 
    "<INPUT TYPE=\"hidden\" NAME=\"baseFrame\" VALUE=\"$baseFrameURL\">";
	$frameOption = 
    "<INPUT TYPE=\"hidden\" NAME=\"frameString\" VALUE=\"$frameString\">";
	# The following is unpredictable, unfortunately.
	# $javascriptCloser = 'onSubmit="this.submit(); close(); return false;"';
    }

    if ($upRel eq "None") {
    #  $upRel = "";  there is always a relation now.
    }

    $email = $form{Email};
    # Get explict UserID or use email or authenticated remoteUser
    $userid = $form{UserID} || $email || $remoteUser;
    # remoteUser might be different from userid.
    $remoteUser ||= $userid;
    &HNMsg("remoteUser: $remoteUser \n") if $debug;
    $password = $form{Password};

    my $URCfile = "$hndocs$URL,urc";
    %urc = &parseURCFile($URCfile);

    $responses = $urc{'Responses'};
    $upTitle = $urc{'Title'};

    $base = $urc{'BaseURL'};

    &access1($addResponseSF, 2, $userid, $remoteUser, 
	     "User <strong> $remoteUser
   </strong> is not permitted to add a message for <B>$userid</B>.<p>", 
	   $authenticated, $base);


    # ==========================
    # Go through the user supplied data, remove dangerous things,
    # check for missing things, etc.
    # Also need to truncate text that is too long!!

    $title = &removeNL($title);

    # Make an empty title "Untitled".
    # I prefer this to "Re: <previous title>" because it is too easy
    # for people to use that and it means very little.  However, no
    # title is not good either.  So hopefully, this will encourage
    # people to make an appropriate title.

    if ($title =~ "^[ \t\n]*\$") { $title = "Untitled"; }

    $referenceURL = &removeNL($referenceURL);
    $keywords = &removeNL($keywords);

    $remoteUser = &removeNL($remoteUser);
    $userid = &removeNL($userid);
    $email = &removeNL($email);
    $userName = &removeNL($userName);    # Should disallow ()s in name

    &HNMsg("remoteUser = '$remoteUser'; email = '$email'") if $debug;
    if ($userid) {
	my %member = &getMember($userid);
	&printAssoc('member', %member) if $debug;
	$userid = $member{UserID} || $userid;
	$userName ||= $member{Name};
	$email = $member{Email};
    }

    $date = &wwwdates::wtime(time, 'GMT');

    $bodyURL = &saveBody($body, $contentType, "/hn_tmp$$");

    # Stick all variables in an assoc list, just as for add-response
    my (%response) = 
    ('Title' , $title,
     'URL' , $URL,		# really upURL relative.
     # 'MessageID', $messageID, # Not for HyperNews posting.
     # 'Path', $messagePath,
     'Keywords' , $keywords,
     'AnnotationType' , $annotationType,
     'ContentType' , $contentType,
     'Body' , $bodyURL,
     'UpRel' , $upRel,
     'BaseURL' , $base,
     'Responses' , $responses,
     'From' , $userid,
     'Password' , $password,
     'Name' , $userName,
     'Date',  $date,
     'AdminPassword', $form{adminPassword}  # hack to pass this through.
    );

    if ($command eq 'Post your Message') {
      &AddResponse('notify', 0, %response);
      &addResponseResult();
      &printEnd();
    }
    else {
      &previewResponse(%response);
    }
}


sub removeNL {
    local($string) = @_;

    $string =~ s,\n, ,g ;
    $string;
}
