#!/usr/bin/perl -T
# reset-password.pl - reset password of a member.
# Copyright Board of Trustees of the University of Illinois at UC, April 1995

# Add current directory to load path.
$0 = $ENV{SCRIPT_FILENAME} if $0 =~ m{^/dev};
$0 =~ m{^(.*)/[^/]+$ }x;   $hnbin = $1 || '.';
unshift(@INC, $hnbin, "$hnbin/.scripts"); 

require "Admin/hnrc";
&feval('&resetPasswordPL()');

sub resetPasswordPL {
  require "urc.pl";
  require "formlib.pl";
  require "change-member-lib.pl";
  
  my $URL = $ENV{'PATH_INFO'};
  
  &print_HTML_HEAD("Resetting $hnSystemName Member Password");

  my %form = &GetFormArgs();

  &checkAuthenticated($form{remoteUser}, $form{password});

  $qs = $ENV{QUERY_STRING};
  &HNMsg("Query string: '$qs'") if $debug;
  my %args = &parseQueryString();
  $userid = $form{'userid'} || $args{userid} || $qs || $remoteUser;

  if ($userid) {
      $userid = &untaintID($userid);
      $userid = &useridOf($userid);
  }
  
  $reset_flag = $form{Reset};
  if ($reset_flag) {

    if (!$userid) {
	&HNUserError("You must provide a $UserIDorHandle.");
    }

    &access1($resetPasswordSF, 3, "",  $remoteUser,
	     "User <strong> $remoteUser </strong> doesn't have permission to reset password for $userid",
	     $authenticated);

    &logTransaction("reset password", $URL, "member");

    print ("<H2> Resetting $hnSystemName Member Password</H2>");
    
    if (!$debug) {
      &resetPassword($userid, $remoteUser);
    } else {
      print "Would have Reset Password for $userid<P>\n";
    }
    print "<P> You can reset another password below. <P> <HR>"
  } 
  
  
  if (!$authenticated) {
    if ($resetPasswordSF <= 2) { $memberOrAdmin = 'You'; }
    elsif ($resetPasswordSF == 3) { $memberOrAdmin = 'Administrator'; }
    $passwordOption = 
      "<STRONG>$memberOrAdmin</STRONG> ($UserIDorHandle): <BR>
<INPUT NAME=\"remoteUser\" SIZE=35 MAXLENGTH=65 VALUE=\"$remoteUser\"> <P>
      
<STRONG>Current Password </STRONG> (of $memberOrAdmin): <BR>
<INPUT NAME=\"password\" TYPE=\"password\" SIZE=8 MAXLENGTH=8> <P>";
  }
  
  local($whoisthis) = &sustring($remoteUser);
  
 
  print qq{

<H2>Reset a Password</A> </H2>

$whoisthis<P>

This form lets you reset the password for a user to a new, randomly
chosen password.  <P>

<FORM ACTION="$editResetURL" METHOD="POST">

<STRONG>$UserIDorHandle</STRONG> 
(of User whose password is to be reset): <BR>
<INPUT NAME="userid" SIZE=35 MAXLENGTH=65 VALUE="$userid">
<P>

$passwordOption
$urlOption
<INPUT TYPE="submit" NAME="Reset" VALUE="Submit">

<HR>
<H3> 
|
<A HREF="$instructionsURL#Membership">
Help for $hnSystemName</A>
| </H3>
</FORM>
};

    &printEnd();
}
