#!/usr/bin/perl -T
# thread.pl  ---  Next/previous-in-thread
# Copyright Board of Trustees of the University of Illinois at UC
# September 1995

# Add current directory to load path.
$0 = $ENV{SCRIPT_FILENAME} if $0 =~ m{^/dev};
$0 =~ m{^(.*)/[^/]+$ }x;   $hnbin = $1 || '.';
unshift(@INC, $hnbin, "$hnbin/.scripts"); 

require "Admin/hnrc";
&feval('&threadPL()');

#********************************************************

sub threadPL {

    require "urc.pl";
    require "formlib.pl";

    local($Action, $URL);
    local($debug) = 0;

    # No authentication here?

    $URL = $ENV{'PATH_INFO'};
    $URL = &untaintPath($URL);
    #&ErrorIfTainted($URL);
    my %in = &parseQueryString();
    $action = $in{'dir'};
    $showInvisible = $in{'show'};

    if ($allowFrames) {
	$bFrame = $in{'frame'} eq 'newset';
	$rFrame = $in{'frame'} eq 'response';
	&frameVariables() if ($rFrame || $bFrame); 
    }

    local($dir) = $URL;
    local($baseDir) = &getBaseURL($dir);
    &HNMsg("baseDir: $baseDir\n") if $debug;

    $dir =~ s{\.html$ }{}x;
    &HNMsg("dir: $dir\n") if $debug;


    ## if ($action eq 'next_in_thread', or 'nextThread', or 
    ## 'nextResponse', 'previousResponse')
    local($next);
    if ($action eq "next-in-thread"){
	$next = &findNextinThread($dir, $showInvisible);
    } elsif ($action eq "nextThread"){
	$next = &findNextThread($dir, $showInvisible);
    } else {
	$next = &findNorPResponse($dir, $action, $showInvisible);
    }

    $next = "$getURL$next";

    if ($bFrame){
	$next .= "?$resetFrame";
    } 
    elsif ($rFrame){
	$next .= "?$qsOfFrame";
    }

    # Return a redirect.  We could instead *do* the redirect.
    # and return a URI header.
    print "Location: $next\n";

    #&print_HTML_HEAD("$action");
    #print "<P>$action: <A HREF=\"$next\">$next</A>.";
    print "\n";
}


sub findNextinThread {
    local($dir, $showInvisible) = @_;
    local($debug) = 0;

    &HNMsg("directory $hndocs$dir") if $debug;

    if (-d "$hndocs$dir") {
	# If $hndocs$dir exists, get first response, if any.
	local(@files) = &responsesOf($dir);
	if ($files[0]) {
	    local($num) = &responseNumOf($files[0]);
	    return &findResponse($dir, $num, 'nextResponse', $showInvisible);
	}
    }

    # No responses, so in the same level, find the next response.
    return &findNorPResponse($dir, 'nextResponse', $showInvisible);
}


sub findNextThread {
    local($dir, $showInvisible) = @_;

    local($parentDir) = $dir;
    $parentDir =~ s|/[0-9]+$||;

    if ($parentDir eq $baseDir){
	# Go to next response instead.
	&findNorPResponse($dir, "nextResponse", $showInvisible);      
    } else {
	&findNorPResponse($parentDir, "nextResponse", $showInvisible);
    }
}


sub findNorPResponse {
    local($dir, $action, $showInvisible) = @_;
    local($debug) = 0;

    local($parentDir) = $dir;
    $parentDir =~ s|/[0-9]+$||;

    # Parse urc file and fetch the next (or previous) response
    local($urcFilename) = "$hndocs$dir.html,urc";
    %response = &parseURCFile($urcFilename);
    if ($response{'URL'}) {
	if ($action eq 'previousResponse') {
	    if (defined $response{'PreviousNum'}) {
		# If defined, assume it is correct.
		local($file) = &findResponse($parentDir,
					     $response{'PreviousNum'},
					     'previousResponse', 
					     $showInvisible);
		if ($file) { return $file; }
		# Explicitly no PreviousNum, so return parent.
		return "$parentDir.html" if ($response{'PreviousNum'});
	    }
	} elsif ($action eq 'nextResponse') {
	    if (defined $response{'NextNum'}) {
		&HNMsg("NextNum: '$response{'NextNum'}'") if $debug;
		local($file) = &findResponse($parentDir, $response{'NextNum'},
					     'nextResponse', $showInvisible);
		if ($file) { return $file; }
		if ($response{'NextNum'}) {
		    if ($parentDir eq $baseDir) {
			# go back to $baseDir if parent is Base article.
			return "$baseDir.html";
		    } else {
			return &findNextThread($dir);
		    }
		}
	    }
	}

    }

    # If next (or previous) doesn't exist, compute it from dir list.
    local(@files) = &responsesOf($parentDir);
    &HNMsg("Array of files is: @files") if $debug;
    local($index);

    if ($action eq "nextResponse") {
	$index = @files-1;
    } else {
	$index = 0;
    }

    local($filetofind) = "$dir.html,urc";	
    $filetofind =~ s|^$parentDir/||;

    # If the file used is last (or first) one in the level, go up a level.
    &HNMsg("Looking for $filetofind") if $debug;
    if ($filetofind eq @files[$index]) {
	if ($action eq 'nextResponse') {
	    &HNMsg("Going up from $response{URL}") if $debug;
	    if ($response{'URL'}) {
		# Write out empty NextNum
		$response{'NextNum'} = "";
		&writeURC($urcFilename, %response);  # should have been locked.
	    }
	    if ($parentDir eq $baseDir){
		# go back to $baseDir if parent is Base article.
		return "$baseDir.html";
	    } else {
		return &findNextThread($dir);
	    }
	} else {  # $action eq 'previousResponse'
	    if ($response{'URL'}) {
		# Write out empty PreviousNum
		$response{'PreviousNum'} = "";
		&writeURC($urcFilename, %response);
	    }
	    return "$parentDir.html";
	}
    } else {
	$index = &computingURL($filetofind, @files);
	&HNMsg("index in sub findNextResponse: $index") if $debug;

	if ($response{'URL'}) {
	    # Write out NextNum and PreviousNum
	    # Even though the urc files exists, it be bad.
	    $response{'NextNum'} = &responseNumOf($files[$index+1]);
	    $response{'PreviousNum'} = &responseNumOf($files[$index-1]);
	    &writeURC($urcFilename, %response);
	}
	if ($action eq "nextResponse") {    
	    $index++;
	} else {
	    $index--;
	}

	local($file) = &responseNumOf($files[$index]);
	&findResponse($parentDir, $file, $action, $showInvisible);
    }
}

sub responseNumOf {
    local($file) = @_;
    $file =~ m|([0-9]+)\.html,urc$|;
    return $1;
}
    

sub findResponse {
    my($dir, $num, $direction, $showInvisible) = @_;
    # Return $file if it exists and is visible, otherwise return null.

    &HNMsg("dir: $dir\nnum: $num\ndirection: $direction\nvisible: $showInvisible") if $debug;

    if ($num =~ m,/,){
	$num =~ s|^/? *||;  # remove cruft
	$response{'NextNum'} = $num;
	&writeURC($urcFilename, %response);
    }

    if ($num) {
	local($file) = "$hndocs$dir/$num.html,urc";
	&HNMsg("file: $file") if $debug;
	local(%urc) = &parseURCFile("$file");
	if ($urc{'URL'}) {
	    if ($showInvisible) {
		return "$dir/$num.html";
	    } else {
		# Also need to check whether visible.
		&printAssoc('URC', %urc) if $debug;
		# Default is visible
		if ($urc{'Visibility'} eq "Invisible") {
		}
		return "$dir/$num.html";
	    }
	}
	# Otherwise:  This looks dangerous here.
	&findNorPResponse("$dir/$num", $direction, $showInvisible);
    }
}


sub responsesOf {
    local($dir) = @_;
    # return a sorted array of responses in the directory named by $dir
    local(@files);
    local($tmp) = "$hndocs$dir";
    opendir (DIR, "$tmp");
    @files = readdir DIR;
    closedir DIR;
    @files = grep (/^[0-9]+\.html,urc$/, @files);
    @files = sort {$a <=> $b} @files;
    return @files;
}


sub computingURL {
    local($filetofind, @files) = @_;
    # Return the index of filetofind.

    local($debug) = 0;

    local($current) = -1;
    foreach $file (@files) {
	$current++;
	&HNMsg("external current is $current\n") if $debug;
	if ($filetofind eq $file) {
	    &HNMsg("CURRENT ID $current\n") if $debug;
	    last;
        }
    }
    &HNMsg("current is $current\n") if $debug;
    return $current;
}
