#!/usr/bin/perl -T
# view-member.pl - view a member's information.
# Copyright HyperNews.org, 1998

# This is used via a URL like:
#  http://www.hypernews.org/HyperNews/view-member.pl?user

# Add current directory to load path.
$0 = $ENV{SCRIPT_FILENAME} if $0 =~ m{^/dev};
$0 =~ m{^(.*)/[^/]+$ }x;   $hnbin = $1 || '.';
unshift(@INC, $hnbin, "$hnbin/.scripts"); 

# print "INC: @INC\n";

require "Admin/hnrc";

&feval('&ViewMember()');

sub ViewMember {

    require "urc.pl";
    require "member-lib.pl";

    &checkAuthenticated();
    my $isAdmin = $authenticated && &isAdmin($remoteUser);
 
#    &HNMsg("hndocs: $hndocs");
#    &HNMsg("SCRIPT_NAME: $ENV{SCRIPT_NAME}");
#    &HNMsg("hnprefix: $hnprefix");
#    &HNMsg("hnbinURL: $hnbinURL");

    my $whoami = &sustring($remoteUser);
    if ($whoami) { $whoami = "You are: $whoami <BR>"; }
    my $whoisthat;

    my %admin = &getMember(@hnAdmin[0]);
    my($adminEmail) = $admin{'Email'} || $hnAdmin[0];

    my $userid = $ENV{QUERY_STRING} || $remoteUser;
    &HNMsg("userid is $userid, Remote User is $remoteUser") if $debug;

    if ($authenticateInquiries || $hideUserIDs) {
        if ($userid && ($userid ne $remoteUser) && !$isAdmin) {
                &HNUserError("You are not permitted to inquire about
 other members - all member data is private.");
        }
    }
 
    # my $URL = $ENV{'PATH_INFO'};

    my %member;
    if (!$userid) {
	&HNUserError("The userid is missing");
    }
    else {
	# &HNMsg("Getting New Member info for $userid");
	%member = &getMember($userid);
	# &printAssoc('member', %member);

	$newUserID = $member{'UserID'};
	#&HNMsg("userid: $userid  newUserID: $newUserID");
	$emailAddress =  &addressOf($userid);
	$userName = $member{'Name'};
	$userURL = $member{'UserURL'};
	$userPhone = $member{'Phone'} || $member{'UserPhone'};
	$userAddress = $member{'MailAddress'} || $member{'UserAddress'};
	$content = $member{'Content'};
	$format = $member{'Format'};

	my $memberOrAdmin = "a member";
	if (&isAdmin($userid)) {  # In what group?
	  $memberOrAdmin = "an administrator";
	}

	my $groupName = $hnGroup;
	$groupName =~ s,^/,,;

	if ($newUserID) {
	  if ($newUserID ne $remoteUser) {
	    if ($newUserID ne $userid) {
		$whoisthat =  "\"$userid\" has $UserIDorHandle \"$newUserID\".";
		$userid = $newUserID;
	    }
	    if ($hnGroup) {
		if (-e "$hnPeople$hnGroup/$userid") {
		    $whoisthat .= "  $userid is $memberOrAdmin of \"$groupName\".";
		}
		else { $whoisthat .= "  $userid is not a member of \"$groupName\"."; }
	    } else { $whoisthat ||= "  \"$userid\" is $memberOrAdmin."; }
	  }
	} else { $whoisthat .= "  \"$userid\" is not a member."; }

	$whoisthat = " <STRONG> \n $whoisthat </STRONG> <P>\n"
	    if $whoisthat;
    }

#============================================

    &print_HTML_HEAD("$hnSystemName Member Info");

#    &HNMsg("2. userid is $userid, Remote User is $remoteUser");

    if ($hnGroup) {
	$groupScope = " in group $hnGroup";
    }

    print qq{
    <H2>$hnSystemName Member Info: <i>$member{Name}</i></H2>

};

    my $subscribeOption;
    if ($allMemberForums ne 'none' &&
	($member{Subscribe} eq 'all')) {
       $subscribeOption = qq{
 All forums that subscribe All-Members.
};
    }
    elsif ($member{Subscribe} eq 'none') {
       $subscribeOption = qq{
 Nothing - Unsubscribed from all forums at this site.
<P>
};
}
    else {
       $subscribeOption = qq{
 Only what I specify in each forum.
};
}

    my $userURL = $member{UserURL};
    my $userURLText = qq{
<A HREF="$userURL">$userURL</A>
} if $userURL;

    my $fields = '';

    $fields .= &viewMemberField('Name', $member{Name});

    my $hideEmailAddress = 
	$hideEmailAddresses || ($member{Hide} eq 'Email');
    
    $fields .= &viewMemberField 
	('Email Address',
	 qq{<A HREF="mailto:$emailAddress">$emailAddress</A>}) 
	    if !$hideEmailAddress;
    $fields .= &viewMemberField($UserIDorHandle, $userid) 
	if !$hideUserIDs && %member;

    $fields .= &viewMemberField('Personal URL', $userURLText);
    #$fields .= &viewMemberField('Subscribe to', $subscribeOption);

    my %memberFields = &parseURCFile("$hnPeople/.member-fields");
    foreach $name (keys %memberFields) {
	my ($maxlength, $xsize, $ysize, $description) = 
	    split ('\|', $memberFields{$name});
	$fields .= &viewMemberField($name, $member{$name});
    }

# Note that each HyperNews site has its own set of members. <BR>
# and is located at <A HREF="$topURL">$topURL</A>
    print qq{
<HR>
<P>
$whoami
$whoisthat
<P>
<TABLE>

$fields

</TABLE>

<P>
<HR>
<P>

 This site is called "<B>$hnSystemName</B>".  <BR>
 The administrator is <a HREF="mailto:$adminEmail"><B>$adminEmail</B></A>.
<P>
};

	print "\n<P><TABLE><TR>\n";


	if ($joinSF == 1 && !$authenticated) {
	    print qq{
<TD>
<FONT SIZE=+1><B>
[<A HREF="$editMemberURL?new">Register (Become a Member)</A>]
</B></FONT>
</TD>
 };
    }

	print qq{
<TD>
<FONT SIZE=+1><B>
[<A HREF="$SECUREDeditMemberURL">Edit YOUR Member Info</A>]
</B></FONT>
</TD>
 };


    if ($isAdmin) {
	print qq{
<TD>
<FONT SIZE=+1><B>
[<A HREF="$SECUREDeditMemberURL?userid=$userid">Edit Member Info for $userid</A>]
</B></FONT>
</TD>
 };
    }

    print "\n</TR></TABLE>\n";

    &printEnd();
}


sub viewMemberField {
    my ($name, $value) = @_;
    return '' if !$value;
    return qq{
<TR> <TD valign="top">
<STRONG> $name </STRONG> 
</TD>
<TD valign="top">
$value
</TD> </TR>

};
}
